Title page

Explorer++ Help

 About

Having difficulty getting around...?

Explorer++

can help!


About - Explorer++

Current: v1.3.3

Explorer++ is a free multi-tab file manager for the Windows® operating system, released as open source under the GNU GPLv3 license. Windows® Explorer provides basic functionality - the ability to navigate throughout your computer, and perform basic tasks - but Explorer++ goes further, introducing several enhancements and improvements for a much richer file browsing experience. Aside from basic navigation, Explorer++ has:

  • a two paned interface, like Windows® Explorer, but with multiple tabs in the fileS pane. You can have many locations open at once and quickly change from tab to tab.
  • a Drives toolbar, showing all available volumes - disk drives - (including network and USB drives). Jump to a drive with a single mouse click.
  • a Bookmarks menu (similar to Windows® Explorer favorites, but with more functionality), and a Bookmarks toolbar
  • an Application toolbar where you can create shortcuts to your favorite applications
  • Show Command Prompt built into Explorer++
  • attribute control (set, clear) for multiple files
  • various methods of file display, including multiple groupings
  • quickly split a large file into pieces, for email or other purposes, and quickly merge pieces back into the original file
  • a destroy files function which deletes files, then wipes their former disk space clean. This provides secure erasing of files.
  • a built-in file search function which allows searching by name or attributes
  • customized file display colors, by name or attributes
  • ability to run in portable mode, storing all configuration in an XML file
  • highly configurable, for user preference
  • full drag-and-drop support with other applications, including Windows® Explorer
  • much more...!

Explorer++ requires Windows® XP, Vista or Seven (32 bit or 64 bit systems) to run; there is no installation required.

Explorer++ uses English as its native language, but can be used with other languages through the use of translation DLLs, available on the website. Translations are user contributed (thanks for the work!), and as a result, some may be incomplete.

Note: Windows (and other Microsoft terms in this document) is a registered trademark of Microsoft Corporation in the United States and other countries. Subsequent use of any Microsoft trademark in this document will not include the ® symbol, for convenience, but that symbol should be implied.


About - Help

 Help File
Compiled: November 3/11

This help file has incorporated several interesting features to aid in usage:

  • a table of contents, organized by topic
  • an index with common topics identified
  • full-text search to aid in finding specific items
  • an accessibility aid - adjustable font size - available from the icon bar
  • image links for quick navigation through most of the topics - see Navigate on the icon bar
  • a Favorites tab which allows the user to bookmark commonly used topics
  • special Contents (available from the icon bar) and Index (available from Contents ) pages which allow the same usage as the Contents and Index in the navigation panel, but with the panel closed for maximum screen usage
  • some samples of listings or text files as needed, embedded in this help file

This document uses 3 distinct styles of hyperlinks, with rollover characteristics:

  • local (internal) links, which look like this,
  • external links, which open a web page in your browser and
  • image rollovers, which look like this [image] (hover your mouse over the menu headings)

Hyperlinks may sometimes have tooltips - text which pops up when the mouse is paused over the link (ie. hovered) - which could clarify the topic or provide useful information.

In addition to the usual explanations and descriptions, some pages may contain special text as follows:

Tip: Tips (and tricks) provide additional useful information, perhaps not immediately obvious to the topic.
Info: Useful information, but perhaps not specifically related to the topic at hand.
Caution: Warnings are made if some operations may be dangerous to your data, etc.
Bug: Unfortunately, Explorer++ has a few bugs; every program does. Bugs may vary from version to version. Most of the bugs have been reported and are "in the queue" for fixing. If Explorer++ were already perfect, there would never be any improvement!
Incomplete: Some of Explorer++'s features have been created, but not completed. The author may have only partially implemented the feature for now; future releases may enhance the current capabilities.

Note: Some images (screen captures) have been modified (eg. resized) and may not appear exactly as they will in Explorer++. Screen captures have been done in Windows XP SP3; if your system is Vista or Windows 7 menus, etc. may appear slightly different - efforts will be made to include screen captures, etc. from those newer operating systems. In addition, some references to locations or tools (eg. Start Menu) may be applicable only to Windows XP; more recent versions of Windows (ie. Vista, 7) may use different terminology or controls.

This help file was created as a volunteer effort - please accept it in that spirit. While every effort has been made to ensure that the information contained herein is accurate, it may not be complete. Please do not read this help file as the "last word in using Explorer++ - any issues or bugs not discussed here can be dealt with by contacting the program's author:

email: david@explorerplusplus.com
on the forums: http://www.explorerplusplus.com/forum

- Allen T., British Columbia, Canada


User Manual/Search Tab

Using Search Effectively

Click or Hover on an item for more ...

This electronic book (Explorer++ - Help File) contains a great deal of information about the program and its use. The manual is organized using menus and topics, but it may sometimes be difficult to find the right information! This book's Search tab can help in this regard, but Search has more power than might be evident on the surface. Following are some hints for using Search effectively.

use HIGHLIGHT On the tool bar, click Options and make sure that the Search Highlight feature is ON. If the menu item says "Search Highlight Off", then the feature is already enabled. This feature will highlight items in the text that are found by the search.
use WILDCARDS The search utility normally looks for words (or phrases) as-is (not case sensitive). This means that a search for the word divide will not find any occurrences of the word divides Use wildcards to expand your search:
* | including an asterisk (ie. *) somewhere in the search target finds more combinations of the target, just as it does from a DOS (or Command) prompt. The asterisk stands for any (optional) multiple characters. Using divid* as the target finds divide, divided and dividing as well. The search target *divid* finds all the previous, plus will find individual, etc.
? | including a question mark somewhere in the search target finds any (mandatory) single character in that position. Using divide? as the target finds divides, divider and divides but won't find divide or dividing.

Enabling the Match similar words option will help to find plurals, etc., but a wildcard search can be more versatile.
use PHRASES Searching for ctrl key finds occurrences of both words in the same topic, but not necessarily together! Using "ctrl key" (enclosed in double quotes) treats it as a phrase and only finds that phrase. Quotation characters cannot be found using the search, since they enclose a phrase. Note that when searching for file names with extensions (eg. EXPLORER++.EXE), use a phrase also (eg. "EXPLORER++.EXE") otherwise the period will separate the search into 2 distinct words.
use BOOLEANS

 If you are looking for more than one word (or phrase), you may separate them with one of the reserved boolean words to restrict your search:
AND | Topics must contain both words, eg. tip AND key will only find topics containing both words or phrases. Note that tip AND key is equivalent to tip key .
OR | Topics may contain either word or both words. Searching for ctrl OR alt finds topics containing either or both of the words, anywhere in the topic.
NOT | Topics may not contain the word or phrase following NOT, as in ctrl NOT alt, which will find occurrences of ctrl, providing alt is not found on the page.
NEAR | Topics must contain both words or phrases, but close together. A search for macro NEAR user will find phrases containing both words, but will not find pages where the words are far apart. This search mode is not effective where pages/topics are short, since close together and far apart are not precise terms; NEAR works best on larger documents or pages.

Searching in the Document pane

Once you are reading a particular page, it is also possible to search for a word or phrase within that page by:

  • clicking the mouse on the right-hand pane (ie. the actual page you are reading), preferably near the start of the page. This sets Windows' focus on the text, although usually no visible change is evident.
  • press <ctrl>F to initiate the Find dialog
  • follow the instructions in the dialog (simple search options)

Unfortunately, the search highlight color in the document pane is not changeable; highlighting words which are already written in the highlight color (or close) renders them difficult - but not impossible - to see.

Tip: If a global search has been done which highlights certain phrases or words, and a search within that page follows which uses the same words, the highlight colors may not be as expected. A work-around to this behavior is to turn off search highlighting (using the Options button on the Help file's toolbar) and reload the page by re-selecting it from the original global search results.


Revision History - current version

Revision History

Explorer++'s revision history has been included here and may be useful for the following reasons:

  • it demonstrates how much effort has been put into the application, and an approximate time line for same,
  • features which have not been documented (eg. hotkeys, special operations) may be uncovered,
  • behaviors which might be considered bugs can be traced to see if they are intended, and
  • more insight into how things work can be gleaned.

The full-text search capability of this document (along with the page titles) can be used effectively to search for a particular item, if you have a concern. Otherwise, it still may be valuable reading.

Version 1.3.3 (29/10/2011) - Current version

New features:

  • n/a

Bug fixes:

  • The media duration column was previously showing times in 100-nanosecond units. Updated to hh:mm:ss.

  • The processed search string (rather than original search string) was been stored in the search dialog. Fixed.

Misc:

  • When searching using the search dialog, if the filename entered already appears in the history list, it will simply be swapped to the first position (rather than been re-entered).

  • The number of history entries stored for the filename field in the search dialog is now capped at 20.

Info: On the 64-bit version of Windows, the control panel may not show all items, and any 64-bit shell extensions will not work. If you have a 64-bit version of Windows, it is recommended that you use the 64-bit version of Explorer++.


Revision History - current version

Revision History

Version 1.3.2 (11/10/2011)

New features:

  • n/a

Bug fixes:

  • Under some circumstances, a copy and paste/drag and drop operation would fail (when copying a message from Outlook 2010, for example).

  • Fixed bug in customize colors dialog (entries were not been moved up/down correctly).

  • When renaming a file in the listview with IME turned on, text was been overwritten (because the text selection was modified). Fixed.

  • Links to zip files will now be opened in an external program, if Open zip files in Explorer++ is unchecked.

Misc:

  • n/a


Revision History - current version

Revision History

Version 1.3.1 (05/09/2011)

New features:

  • The sort mode and direction are now saved in the search dialog.

Bug fixes:

  • The image in the about dialog would not be shown when a translation was loaded. Fixed.

Misc:

  • The help file (if present) can now be launched from the Help/Help menu. It must be named Explorer++ Help.chm and be in the same folder as the Explorer++ executable.

  • Updated Always hide the link (.lnk) extension option to read Hide the link (.lnk) extension.


Revision History - current version

Revision History

Version 1.3 (20/08/2011)

New features:

  • The complete state of most dialogs are now saved.

  • Most dialogs can now be resized.

  • Significant improvements to split file dialog.

  • Context menu extensions are now shown on the main right-click context menu.

  • Enhanced undo functionality. Multiple rename operations (such as those performed by the mass rename dialog) can now be undone as a single set.

  • Delete permanently button added to main toolbar.

  • Added Close Tabs to the Right entry to the tab right-click menu.

  • The listview hover time can now be set by the user.

  • Right-clicking search dialog results now brings up the file context menu.

  • Search dialog results can now be sorted by name/path.

  • Added Case sensitive option to filter dialog.

  • The folder navigation sound can now be disabled via the options dialog.

  • The search dialog can now search using regular expressions. A case insensitive flag has also been added.

  • Deleting an item in the treeview will select the parent folder prior to deletion (allowing the previously selected folder to be deleted).

  • Right-clicking on the root desktop folder in the treeview now brings up its context menu.

  • Trailing spaces are now trimmed when renaming an item in the listview/treeview.

Bug fixes:

  • In Windows 7 when closing a tab, the wrong taskbar preview pane would be closed (i.e. the taskbar preview pane for another tab would be closed instead).

  • Fixed a crash that occurred when collapsing a node in the treeview.

  • When single-click activation was enabled, and an area in the listview was selected, any file under the mouse when it was released would be opened. Fixed.

  • Fixed Open Parent in New Tab bug (parent of current tab would always be opened, regardless of which tab was clicked).

  • When opening a folder in a locked tab, the newly created tab was not switched to correctly (which caused directory modifications to fail, for example). Fixed.

  • Fixed toolbar bug (when a button was added or removed from a toolbar, the length of the toolbar would be reset, causing it to resize).

  • Fixed listview gridline issue (Windows XP only).

  • Under certain circumstances, translation DLL's would still be loaded, even if they did not match the current version. Fixed.

  • Filename extension is now hidden correctly (if required) in details view.

  • Size column now remains right aligned after sorting.

  • When allow multiple instances was not set, and a new instance was started, it would not restore the previous window correctly if it was minimized. Fixed.

  • Summary information stream codepage wasn't being checked. Fixed.

  • Fixed control panel handling bug.

  • Fixed drag and drop memory leak.

  • Fixed bugs in mouse wheel handler.

  • Fixed bug in options dialog (apply button not enabled when changing size selection in files and folders tab).

Misc:

  • Version number now takes the form: Major.Minor.Micro.Revision.

  • Improved drag and drop interoperability.

  • File sizes are now formatted according to the current system locale.

  • When collapsing the direct parent of the current folder in the treeview, the listview selection would change to the parent. Now works when collapsing multiple levels.

  • The Size On Disk, Total Size, and Free Space columns are now right aligned.

  • The current directory is now set when the directory or tab selection changes. Updated Handle zip files option to read Open zip files in Explorer++.

  • The error message shown on a translation DLL version mismatch will now be shown in the target language (when possible).

  • The (main) right click context menu is no longer owner drawn.


Revision History - current version

Revision History

Version 1.2 (13/09/2010)

Major changes for this version include several Windows 7 specific features, such as per-tab taskbar thumbnails, and a 'New Tab' jump list task. As with the previous version, there have also been some significant improvements to drag & drop. These improvements include both a wide range of bug fixes, as well as some new functionality. One example of this new functionality is the ability to copy and paste/drag & drop text and images into Explorer++ directly.

New features:

  • Taskbar thumbnails are now shown for each tab in Windows 7 (this can be turned on/off by toggling Show taskbar thumbnails in the Options dialog).

  • New Tab added to Tasks jump list in Windows 7.

  • Numerous improvements to drag and drop/copy and paste.

  • Text on the clipboard can now be pasted as a file. The file will be given a name of the form:
        Clipboard Text ([datetime]).txt
    This also applies to drag and drop.

  • Images on the clipboard can now be pasted as a file. The file will be given a name of the form:
        Clipboard Image ([datetime]).bmp
    This also applies to drag and drop.

  • The contents of the address bar can now be dragged and dropped.

  • Large toolbar icons added.

  • Files can now be dropped onto existing application toolbar buttons. This will open the dropped files in that application.

  • Automatically synchronize treeview with main pane option added; this setting controls whether or not the treeview will automatically stay in sync with the listview whilst browsing.

  • Automatically expand nodes on selection option added; if this setting is enabled treeview nodes will automatically expand when they are selected.

  • Shift+Mousewheel down and shift+mousewheel up can now be used to browse backwards and forwards, respectively.

  • The tab bar can now be hidden when there is only one tab.

  • The tab bar can now be shown at the bottom of the listview.

  • A navigation sound is now played when entering a folder.

  • The current folder is now selected when navigating up.

  • Listview groups can now be collapsed (Vista and later).

  • Listview checkboxes can now be turned on by selecting Use check boxes to select items in the Options dialog.

  • Closing the last tab will now close the main window (provided the corresponding option is selected in the Options dialog).

  • Items can now be rearranged in details view.

  • It is now possible to show file sizes in one of: Bytes/KB/MB/GB/TB/PB.

  • Ctrl+Backspace can now be used to browse to the root of a tab.

  • Shift+Double Click will now open the selected folder in a new window.

  • Desktop, Pictures, Music, Videos and Documents are all now valid address bar shortcuts.

Bug fixes:

  • Several dialogs weren't closing when Escape was pressed. Fixed.

  • Fixed Copy Universal File Paths bug.

  • Previously, if Hide file extensions was checked, the display names of both files and folders would be altered. Fixed so that only files names are altered.

  • When Single-click to open an item was selected, navigation up would occur on a single click, instead of a double click. Fixed.

  • Fixed directory modification bug.

  • Fixed set file attributes dialog bug (file dates weren't been saved correctly).

  • Fixed treeview rename bug (child items not updated).

  • Fixed treeview sort bug.

  • Fixed toolbar positioning bug.

  • Fixed custom infotips bug.

Misc:

  • All settings are now saved to the registry (or XML file) when Ok or Apply is clicked in the Options dialog.

  • The treeview no longer syncs with network/UNC paths.

  • Copied data now remains on the clipboard after Explorer++ exits.

  • Search dialog now turns patterns of the form ??? into *???* before searching.

  • Main window now obeys startup position information (e.g. minimized/maximized, etc).

  • Wildcard select/deselect is now case insensitive.

  • Can now scroll listview/treeview, even when it does not have focus.

  • The options dialog is now modeless.

  • Handle zip files set to false by default.


Revision History - v1.1

Revision History

Version 1.1 (05/04/2010)

New features in this version include the ability to replace Windows Explorer for all folders (only for Vista and Windows 7), and the ability to go up one level by double clicking in a tabs whitespace.

The major changes for this release, however, centre around drag & drop. For example, it is now possible to drag and drop attachments from a program such as Outlook, as well as drop text from the address bar of a web browser. Both the listview and treeview now make use of the same drag and & drop code (the copy and paste system also uses this code), meaning the listview and treeview will both support the same drop formats. These formats will also be supported via copy and paste.

There have also been a few important changes to the treeview. For instance, icons are gathered in a background thread, which should reduce load times slightly. Furthermore, all treeview items are now sorted correctly. Even though items now have to be sorted, there shouldn't be any performance hit. Expanding the C:\Windows\winsxs folder in the treeview (which has ~10,000 folders in my system) takes about ~3 seconds.

New features:

  • Explorer++ can now replace Windows Explorer for all folders (Vista and later only).
  • New drag and drop type supported (this will now allow files to be dropped from Outlook and url's from a web browser's address bar).
  • Column widths are now saved and restored for all tabs.
  • Added Save Column Layout as Default under the View menu which will save the current tabs column layout as the default.
  • Items in the treeview can now be dragged and dropped using right click.
  • Folder sizes can now be disabled on removable and network drives.
  • The privilege level can now be shown in the title bar by Show privilege level in title bar in the Options dialog.
  • The extended right click menu is now shown when shift is held down and an item is right-clicked.
  • Locked tabs now display a lock icon, rather than the normal folder icon.
  • Double clicking in a tabs whitespace will now navigate to the parent folder.
  • Middle click can now be used to open items in the treeview in a new tab.
  • Middle click can now be used to open items on the bookmarks toolbar in a new tab.
  • Middle click can now be used to open items on the drives toolbar in a new tab.

Bug fixes:

  • All items in the treeview are now sorted correctly.
  • Icons for the treeview are now gathered in a background thread.
  • Icon overlays are now shown in the treeview.
  • When .lnk extensions were hidden, and a file with the .lnk extension was renamed, it would lose its extension. Fixed.
  • When items were renamed, no icon overlay would be set. Fixed.
  • Under certain conditions (for example, when .lnk extensions were hidden in Windows Explorer), and a file of that type was renamed, its extension would be hidden in details view in the 'Name' column. Fixed.
  • When the system font size for menus was changed, the custom menus would be sized incorrectly. Fixed.
  • When the treeview had focus, the file action buttons on the main toolbar (cut, copy, past, delete, etc) would be incorrectly disabled. Fixed.
  • When a tab was locked (lock tab and address), it would not be possible to open a new tab. Fixed.
  • Fixed toolbar bug.
  • Fixed search bug.
  • Fixed drives toolbar issue.

Misc:

  • Explorer++ will now only load translation DLL's that match the version of the main executable.
  • Updated About dialog and image.
  • Added menu image for Edit/Paste Shortcut.


Revision History - v1.0.0.0

Revision History

Version 1.0.0.0 (23/11/2009)

New additions in this version (as compared to the RC) include several minor new features (such as the ability to have new items inserted in their sorted positions, and the ability to browse to the default folder using the keyboard shortcut Alt+Home), as well as a relatively large set of bug fixes and tweaks, most centered around copy and paste/drag and drop.

New features:

  • It is now possible to search for files using Tools/Search.
  • Custom coloring rules can now be applied to the listview (i.e. an items text color can be set based on its filename and/or attributes).
  • Items can now be dragged using the right mouse button (listview only).
  • Tiles view now shows basic file information.
  • New tabs can now be created by double clicking in the blank space to the right of the last tab.
  • Explorer++ can now be restricted to only running one instance by deselecting Allow multiple instances in the options dialog.
  • Large Icons and Extra Large Icons view modes added (Vista and later).
  • It is now possible to browse through tabs by moving the mouse over the tab window, and scrolling with the mouse wheel.
  • Various media metadata columns added (Album, Duration, Composer, etc).
  • Columns can now be rearranged by dragging and dropping them in place.
  • Folder sizes are now included when sorting by size.
  • Universal file paths can now be copied by selecting File/Copy Universal File Paths.
  • New items can now be inserted in their sorted position by selecting Insert new items in their sorted position in the options dialog.
  • System files can now be hidden by selecting Hide protected operating system files within the options dialog.
  • The link (.lnk) file extension can now be hidden by selecting Always hide the link (.lnk) extension.
  • Single click activation mode can now be used by selecting Single-click to open an item (point to select) in the options dialog.
  • Zip files may be opened externally by deselecting Handle zip files within the options dialog.
  • All tabs can now be forced to have the same width by selecting Force all tabs to have the same width in the options dialog.
  • Double clicking a tab will now close it (provided Double click to close a tab is selected in the options dialog).
  • Ctrl+double clicking a folder will now cause it to open in a new tab.
  • Alt+Home will now browse to the default tab folder.
  • In rename mode, F2 will now cycle between selecting an items filename, extension and filename and extension.
  • Ctrl+1...8 will now select the specified tab (between the first and eighth tab).
  • Ctrl+9 will now select the last tab.
  • In rename mode, tab will now select the next item and place it into rename mode.
  • Application toolbar buttons can now have their names hidden (so that only the icon is visible on the toolbar).
  • Right-clicking on the folder icon in the display window will now show the context menu for the selected files (or the normal right-click menu if no items are selected).
  • Ctrl+Scroll will now cycle through each of the view modes within the listview.
  • Ctrl+Pg Up and Ctrl+Pg Down as well as Ctrl+] and Ctrl+[ can now be used to select the previous and next tabs, respectively.
  • Alt+double click will now show an items properties.

Bug fixes:

  • When creating a file/folder in details mode, the item would be selected, but immediately taken out of rename mode. Fixed.
  • Improved listview grouping.
  • Fixed several drag and drop bugs.
  • Improved drag and drop item repositioning.
  • Fixed cut/copy bug.
  • Fixed Open In New Tab treeview bug.
  • File/Set file attributes now works for the treeview as well.
  • Folders with a total size greater than 4GB would have their size shown incorrectly when the Show folder sizes option was enabled.
  • The icon modifier shown when dragging and dropping now matches the action that will take place when the item is dropped.
  • Previously, if file was been pasted into a tab, and the directory of that tab was changed, the files would continue to be added. Fixed.
  • When creating a new tab, its directory would not always be monitored. Fixed.
  • Items would not always be correctly ghosted when they were cut. Fixed.
  • When creating a new folder using the New Folder button on the main toolbar, the item would not be put into rename mode if the current directory was a directory root. Fixed.
  • The Open new tabs next to the current one option was not been correctly read back from the registry, causing it to lose its value between sessions. Fixed.
  • The bookmarks toolbar would not be updated when a bookmark was renamed. Fixed.
  • Fixed double click bug.
  • When switching folders, the column header in details view was not been updated.
  • When entering a folder with an ampersand (&) in its name, the ampersand would be incorrectly translated into an underscore. Fixed.
  • Fixed new menu bug.
  • Improved mass rename dialog.

Misc:

  • Explorer++ will now save a minidump file in the event of a crash. This file is saved to %TEMP%.
  • Explorer++ can now be set as the default file manager by using the command: explorer++.exe -set_as_default
  • Explorer++ can now be removed as the default file manager by using the command: explorer++.exe -remove_as_default
  • Most dialogs are now centered initially, and will save various state information when closed.
  • Options dialog partially redesigned.
  • Items can now be copied, cut and pasted to/from the treeview using Ctrl+C, Ctrl+X and Ctrl+V, respectively.
  • Chevrons are now shown when toolbar buttons do not have enough room to be shown.
  • Columns (in details view) are no longer resized automatically when changing folders or refreshing.
  • Separate Group By menu added, as appears in Vista onwards.
  • If a files name is only partially shown within the listview, it will be added to the files infotip.
  • There is now a confirmation dialog shown when deleting an application button.
  • Various new details shown on display window.
  • Previews on the display window will not be shown if the display window is inactive.
  • Ctrl+R can now be used to refresh a folder.
  • Ctrl+L can now be used to select the address bar.
  • Ctrl+E can now be used to duplicate a tab.
  • Left click drag and drop is now cancelled when the user clicks the right mouse button.
  • Tools/Show drive information removed.


Revision History - v0.9.5.4

Revision History

Version 0.9.5.4 (31/05/2009)

New features:

  • Explorer++ can now be used in place of Explorer for filesystem folders by selecting Replace Explorer for filesystem folders in the Options dialog (requires Administrator privileges).
  • The positions of the main toolbars are now saved and restored between sessions.
  • Folders can now be dragged onto the bookmarks toolbar directly.
  • Files can now be dragged onto the applications toolbar directly.
  • Icons are automatically updated when a file association changes.
  • Any file that can be previewed in Explorer can now be previewed in Explorer++.
  • Pasted files are now selected upon creation (provided no other files are selected).
  • The apps key can now be used to show the main context menu.
  • Enabled drag and drop modifier keys for the tree view.
  • Right clicking the listview header in details mode will now bring up a context menu, which allows columns to be easily turned on and off.
  • The user's name can now be shown in the main title bar.
  • The Move Up and Move Down buttons in the 'Organize Bookmarks' dialog now work.
  • File previews in the display window can now be turned on or off using the Show file previews in display window setting in the 'Options' dialog.
  • F6 and Shift+F6 can now be used to cycle through each window.
  • Ctrl+Enter will now open the selected folder in a new tab.
  • Ctrl+F4 can now be used to close the current tab.
  • Ctrl+Shift+P will now copy the current folder's path to the clipboard.

Bug fixes:

  • When a new file was created, it would not always be put into rename mode automatically [Windows XP only].
  • Previously, the right click context menu would not be shown for some items. Fixed.
  • Fixed listview positioning bug.
  • If file extensions were hidden, and a filename started with a dot, no text would be shown for that item.
  • If file extensions were hidden in Explorer, they would be hidden in Explorer++ as well, regardless of settings. Fixed.
  • Drives are now added/removed correctly from the listview, treeview and drives toolbar.
  • If a cd/dvd was inserted/removed, the entire drive would be added/removed, even though the physical device had not changed. Fixed.
  • Files are now sorted using natural sort order (e.g. file2.txt comes before file19.txt).
  • If the folders pane had focus, and an item was selected, the file associated menus (such as properties) would be disabled incorrectly. Fixed.
  • Fixed several memory leaks.
  • Improved synchronization in details mode.
  • Improvements made to thumbnails mode.
  • Fixed window size issue.
  • Fixed address bar path issue.
  • Fixed thumbnail image positioning error.
  • Fixed back/forward menu bug.
  • Fixed directory monitoring bug.
  • In details mode, if the first column was removed and then added again, the other columns would not be shifted correctly.
  • Items on the "Send to" context submenu may not have worked correctly. Fixed.

Misc:

  • The format of the time and date fields now follows the system time and date format.
  • Clicking the views button on the main toolbar now cycles between the various views, rather than showing the drop-down menu.
  • A small delay has been added to the time between when a file is dragged over a tab, and focus is switched to that tab.
  • There is now a confirmation dialog shown when deleting a bookmark.
  • In empty folders viewed in details mode, each column now has its width set to a default value.


Revision History - v0.9.3.2

Revision History

Version 0.9.3.2 (24/03/2009)

New features:

  • An application toolbar has been added, which allows quick access to any program.
  • Drag and drop modifier keys (Ctrl+Shift, Ctrl, Shift, Alt) now work.
  • Explorer++ is now compatible with paths containing embedded environment variables, such as %systemroot%.
  • The tab control can now be extended across the entire window.
  • Full row selection in details mode can now be turned on or off.

Bug fixes:

  • Removable drives can now be ejected and removed safely while Explorer++ is running.
  • Drives are now inserted and removed from the drives toolbar dynamically, as they are connected and disconnected from the system.
  • If file extensions were hidden, and a file was renamed, the extension would be dropped.
  • When renaming a file within the listview, if the proposed filename ended with a trailing space or period, the rename operation would appear to succeed, even though it had not (as filenames cannot end with a trailing space or period).
  • When a folder was put into rename mode, if its name contained a period, everything before the period would be selected (as for files).
  • Corrected folder system infotip bug.
  • Previously, if files were dragged into Explorer++, and the auto arrange listview style was on, the files would not be repositioned.
  • Fixed drag and drop selection bug.
  • Fixed drag and drop position bug.
  • Fixed several drag and drop memory leaks.
  • When loading from a configuration file, the correct language selection would show up in the 'Options' dialog, but the default language would be used for the UI (regardless of the language that was loaded).
  • The Show In Groups option was not been saved to the XML file. Fixed.
  • The Move Up, Move Down, Enable and Disable buttons now work within the 'Set Default Columns' dialog.
  • Fixed listview focus issue.
  • The background of the listview was previously been set to white, regardless of the system background color.

Misc:

  • The languages shown in the 'Options' dialog are now generated dynamically, based on any translation DLL's within the same directory as Explorer++.
  • The normal rename/replace dialog is now shown when a collision is encountered during a copy/move operation.
  • The main windows can now be cycled through in reverse using Shift+Tab.
  • The size column in details view is now right-aligned.
  • Removed the 'Back' text from the toolbar back button.
  • The 'Filter Results...' menu item under View/Filter has been changed to 'Set Filter...'.


Revision History - v0.9.2.1

Revision History

Version 0.9.2.1 (15/02/2009)

New features:

  • Each tab now has an icon attached to it (the folder icon from the tabs' current directory).
  • The default directory for new tabs can now be set from within the 'Default Settings' pane of the 'Options' dialog.
  • Explorer++ is now compatible with application command buttons and keys, such as the back and forward buttons found on some mice and keyboards.
  • Infotips can now be turned off, set to the system ones (i.e. the ones used by Windows Explorer), or be set to custom (for now, this simply sets the infotip to be the files modification date).
  • Tab lock state and custom name are now saved between sessions.

Bug fixes:

  • Fixed several directory monitoring bugs.
  • Shortcuts that pointed to a website (via a URL) would previously not be opened within the default browser. Fixed.
  • When two files were selected, whose individual sizes were less than 4GB, but whose combined size was greater than 4GB, the combined size would not be shown correctly. Fixed.
  • When a file size was between 1000 and 1024 of the specified unit (bytes, KB, MB, etc), the fourth character would not be shown, causing the size to appear to be incorrect. Fixed.
  • Fixed a paste file bug.
  • If a file that could not be cut (such as a virtual item) was cut anyway using Ctrl+X, the item would be ghosted whether or not it was actually placed on the clipboard. Fixed.
  • The address bar would not scroll horizontally. Fixed.
  • Fixed tab highlight bug.
  • Because of a timing problem, it was possible that when Explorer++ was opened, the first icon(s) shown may not have been correct. Fixed.

Misc:

  • Ctrl+N can now be used to create a new folder.
  • On a rename operation, if a files new name contains an invalid character [\/:*?"<>|], an error dialog will be shown.
  • When an item is put into rename mode by clicking on it twice, only the files name (and not the files extension, if any), will be selected.
  • An error message is now shown when attempting to open a shortcut that points to a non-existent item.
  • Items on the Go menu now have their names taken directly from the operating system. This means, for example, that the 'My Computer' item will be shown as 'My Computer' on XP, but 'Computer' on Vista.
  • Added an error message for the situation when a new folder could not be created.
  • A slight change to the bookmarks key means that bookmarks saved in previous versions will not have their paths loaded in this version (this only affects bookmarks saved to the registry).


Revision History - v0.9.0.8

Revision History

Version 0.9.0.8 (03/02/2009)

New features:

  • Sort by File System now works.
  • Folders created using the 'New Folder' toolbar button or menu item are now automatically selected for rename when they are created.

Bug fixes:

  • Fixed rebar positioning error that occurred when using the "Windows Classic" theme.

Misc:


Revision History - v0.9.0.6

Revision History

Version 0.9.0.6 (31/01/2009)

New features:

Bug fixes:

  • Fixed overflow bug.

Misc:

  • Any previous registry settings can now be cleared using the command: explorer++.exe -clear_settings
    This command should be used if either version Alpha 1 or Alpha 2 have previously been run.


Revision History - v0.9.0.0

Revision History

Version 0.9.0.0 (30/01/2009)

New features:

  • Explorer++ is now built as a Unicode executable.
  • Explorer++ can now save its settings to an XML preference file (config.xml).
  • Explorer++ will attempt to load its settings in the following order:
    1. config.xml (this file must be in the same directory as Explorer++)

    2. the registry

    If neither of these options are available, Explorer++ will switch to using its internal defaults. To save to the config file initially, check the Save preferences to XML file in the 'Options' dialog.

  • Significantly upgraded bookmarks system.
  • Icon overlays (such as those used by TortoiseSVN) are now supported.
  • Items that are created using the shell 'New' menu are now automatically selected and put into rename mode on creation.
  • A file rename operation can now be undone by selection 'Edit/Undo'.
  • Folder sizes are now shown in details view.
  • A drives toolbar is now available, which allows for quick access to any drive.
  • Bands on the rebar can now be repositioned.
  • Tabs can now be renamed, by right clicking on them and selecting 'Rename Tab...'.
  • 'Lock Tab and Address' now works. This option, when selected, will block any directory changes from occurring within the current tab.
  • Folder shortcuts are now opened within Explorer++.
  • When in thumbnails view, image thumbnails are now gathered independently of the main thread.
  • Added 'Open Parent in New Tab' menu item to tab context menu.
  • Added 'Bookmark Tab' toolbar button.
  • Added 'New Tab' toolbar button.
  • Added 'Show Command Prompt' toolbar button.
  • Added 'Organize Bookmarks' toolbar button.
  • Added option to disable treeview delay.
  • 'Show In Groups' now works when sorting by camera model.
  • 'Show In Groups' now works when sorting by date taken.
  • 'Show In Groups' now works when sorting by image width.
  • 'Show In Groups' now works when sorting by image height.
  • 'Show In Groups' now works when sorting by file extension.
  • 'Show In Groups' now works when sorting by file system.
  • 'Show In Groups' now works when sorting by network adapter status.

Bug fixes:

  • All columns could previously be deselected, causing the program to crash. Fixed.
  • Fixed several small memory leaks that occurred in thumbnails view.
  • When at the root of the namespace (i.e. the desktop), refreshing the tab would change the path to the real desktop. Fixed.
  • When at the root of the namespace (i.e. the desktop), the 'New' menu item would not appear on the right click context menu. Fixed.
  • Fixed a problem that occurred when cutting items.
  • Fixed a drag and drop issue that caused an item dragged between tabs not to be moved.
  • When dragging and dropping an item between tabs, the item count in the destination tab and item selection count in the source tab would become corrupted. Fixed.
  • When creating a new tab without the 'auto arrange' style, auto arrange would be set anyway. Fixed.
  • Fixed selection bug.
  • When items (such as executable files) are opened from within Explorer++, their start directory is now set to the directory they reside within.
  • Fixed several small memory leaks that occurred when closing a tab.
  • Improved synchronization between threads.

Misc:

  • The menu selection color is now alpha blended.
  • Drives in the treeview are now sorted by drive letter, rather than drive name.
  • Pressing the space bar will now cause whichever item in the listview has focus to be selected. If not item has focus, the first item is selected.
  • Paths specified on the command line no longer need a trailing backslash. For example, the commands: explorer++.exe C:\ and explorer++.exe C: will both open the C:\ directory in its own tab.
  • A command line usage message can now be shown by typing: explorer++.exe /?
  • Slight changes have been made to the structure of the registry keys used to save program settings. These changes mean that tabs saved in previous versions of Explorer++ will not load in this version.


Revision History - Alpha 2

Revision History

Version Alpha 2 (26/09/2008)

New features:

  • The language to use can now be selected in the 'Options' dialog, in the 'Language' tab. The language Explorer++ uses is based on the following (in order of importance):
    1. Any language specified on the command line.
    2. Any language saved from a previous session (using the above method).
    3. The system default language.
  • Files can now be dragged and dropped onto the treeview control.
  • 'Copy File Paths' can now be used on items in the treeview.
  • 'Cut' and 'Copy' can now be used to copy and move items from the treeview.
  • The 'Back' and 'Forward' buttons on the main toolbar now show what folder is back/forward in their infotip.
  • 'Show In Groups' now works when sorting by title.
  • 'Show In Groups' now works when sorting by subject.
  • 'Show In Groups' now works when sorting by author.
  • 'Show In Groups' now works when sorting by keywords.

Bug fixes:

  • Fixed bug that would cause directory monitoring to stop working under certain circumstances.
  • Fixed listview drag and drop bug.
  • Fixed bug that arose when sorting items by comment.
  • Fixed 'Merge Files' cancel bug.
  • Fixed 'Split File' cancel bug.
  • Fixed small 'Show In Groups' bug.
  • Fixed toolbar show/hide bug.

Misc:

  • A small delay has now been added to the treeview, meaning that when a different folder is selected, it is not browsed to immediately.

(02/09/2008)

New features:

  • 'Show In Groups' now works when sorting by attributes.
  • 'Show In Groups' now works when sorting by file owner.
  • Show In Groups' now works when sorting by file creation date.
  • 'Show In Groups' now works when sorting by date of last access.
  • 'Show In Groups' now works when sorting by short name.
  • 'Show In Groups' now works when sorting by product name.
  • 'Show In Groups' now works when sorting by company name.
  • 'Show In Groups' now works when sorting by file description.
  • 'Show In Groups' now works when sorting by file version.
  • 'Show In Groups' now works when sorting by product version.

Bug fixes:

  • When closing a tab, directory monitoring would sometimes be stopped for a different tab. Fixed.
  • Fixed toolbar bug that would sometimes cause the program to crash on exit.
  • When the column representing the current sort mode is deselected, the sort mode is automatically changed to the first available one.

Misc:

  • Drives in 'My Computer' are now sorted according to drive letter when sorting by name.

(21/08/2008)

New features:

  • Confirmation when closing multiple tabs can now be requested when the 'Ask for confirmation before closing all tabs' option is selected.
  • The main toolbar can now be customized by selecting 'Customize...' on the toolbar context menu or on the View/Toolbar menu.
  • Added an error message for the situation when a file cannot be renamed.
  • Alt+D will now shift focus to the address bar.
  • F4 will now show the drop down for the address bar.
  • Ctrl+B can now be used to access the 'Organize Bookmarks' dialog.
  • The tab button can now be used to switch between the main item pane, the folders pane and the address bar.
  • Gridlines in details view can now be toggled on or off via the Show gridlines in details view option within the 'Options' dialog.

Bug fixes:

  • Fixed 'Remove' button within the 'Destroy Files' dialog.
  • Fixed 'Remove' button within the 'Merge Files' dialog.
  • Fixed bug when moving columns up/down in column selection dialog.
  • Fixed several other small bugs within column selection dialog.
  • The 'Auto Arrange', 'Show In Groups' and 'Sort Ascending' default options are now saved and loaded.

Misc:

  • Default output file when merging is now 'output.txt'.
  • Menu mnemonic characters are now underlined on the main menu after the alt key is used to select the menu.
  • Description of column items are now shown in the 'Select Columns' dialog.

(10/08/2008)

New features:

  • The right click context menu is now owner drawn.

Bug fixes:

  • Fixed bug that would cause the 'Sort By' submenu to be drawn incorrectly.
  • Fixed position of the 'hide folders pane' button.
  • Fixed bug relating to the 'Address Bar' item on the toolbars menu.

(20/07/2008)

New features:

  • Files can now be merged using Actions/Merge Files....

Bug fixes:

  • Fixed Go button bug.
  • The paste button on the main toolbar is now enabled automatically when there are files on the clipboard, and disabled automatically when there are none.

(13/07/2008)

New features:

  • Added 'Autosize Columns' to the 'View' menu, which will resize listview columns to fit in the text of all items.
  • Files can now be dragged and dropped between tabs.
  • Added a main toolbar context menu.
  • The main menus as well as the main toolbar context menu are now owner drawn. Various items on the main menus now have pictures shown along side the menu text.
  • More main toolbar buttons added.

Bug fixes:

  • Improvements made to drag and drop handling.

Misc:

  • Aesthetic changes made to the About dialog.
  • Build date/time is now shown in the About dialog.

(07/07/2008)

New features:

  • Menu help strings are now shown for items on the shell context menus.
  • Added 'Bookmark Folder...' and 'Copy Folder Path' to right click context menu.
  • When browsing into a folder, the path of the folder been loaded is now shown in the status bar (i.e. if browsing into the 'C:\' folder, the text in the status bar will read 'Loading C:\...').
  • Added 'Duplicate Tab' to right click menu for tabs, which will open a duplicate of the specified tab in a new tab.
  • Added 'Lock Tab' to right click menu for tabs to prevent a tab been closed.
  • Tabs can now be bookmarked using the keyboard shortcut 'Ctrl + D'.
  • Files can now be split using Actions/Split File....
  • Files can now be permanently deleted using Actions/Destroy Files....
  • If 'Show Folder Sizes' is activated in the Tools/Options dialog, folder sizes will now be shown in the display window when a folder is selected.

Bug fixes:

  • Fixed 'Refresh Tab' on tab right click menu so that it refreshes the specified tab instead of the one that currently has focus.
  • Thumbnail images are now shown in the correct position when items are sorted in groups.
  • Small bug fixed relating to showing items in groups when sorting by name.
  • Menu help now shows for items on the context menu for individual tabs.

(03/07/2008)

New features:

  • Thumbnails view can now be set as the default view in the 'Default Settings' page of the Tools/Options dialog.

Bug fixes:

  • Bookmarks can now be rearranged and have their properties (name, location, description) changed.
  • Tabs now update when relevant settings in the Tools/Options dialog have been applied.
  • Fixed treeview sorting bug.
  • Folders created are now inserted into their correct position in the treeview automatically.
  • Some improvements made to Tools/Show Drive Information.

Misc:

  • New tabs can be opened with middle click even if the listview window does not have focus.

(01/07/2008)

New features:

  • Thumbnails view has been added to the 'View' menu. As this is the first implementation of thumbnails view, it may still contain some bugs.
  • Added File/Copy Column Text, which will copy the currently selected items' column text to the clipboard.
  • File/Copy Paths can now copy the full paths of multiple items.

Bug fixes:

  • Fixed tab swapping bug.
  • Fixed column sorting bug.
  • Fixed file size bug that arose when files in a directory were deleted then created.

(29/06/2008)

New features:

  • Virtual folders can now be opened from the command line simply by supplying their name: e.g. explorer++.exe "control panel" will open the Control Panel.

Bug fixes:

  • Improvements made to sorting by column.
  • Fixed bug relating to directories opened via the command line.
  • Fixed bug relating to columns not showing up for the printers folder.
  • Folder specific columns added for the 'My Network Places' folder.
  • Additional virtual folders (Recycle Bin, Printers, Network Connections and My Network Places) now have their active columns saved and loaded.
  • Fixed bug where program would sometimes stop responding after the columns for a folder had been changed.

Misc:

  • 'My Network Places' on the 'Go' menu has been changed to read 'Network' on Windows Vista.
  • The items shown on the 'Sort By' menu for a particular tab now depend on the columns that are active for that tab.
  • Menu help messages added for items on the 'Sort By' menu.


Revision History - Alpha 1

Revision History

Version Alpha 1 (26/06/2008)

New features:

  • The display window font can now be changed (via View/Change Display Colours).
  • 'Open in New Tab' added to right click menu for treeview items.

Bug fixes:

  • Fixed combobox keyboard input bug.
  • Image previews in the display window now adjust their width (to maintain the correct aspect ratio) as the display window is vertically resized.

(25/06/2008)

New features:

  • Additional settings added to default options dialog (auto arrange, show in groups and sort ascending).
  • The program can now be launched from the command line with a set of directory arguments: explorer++.exe dir1 dir2 ... dirN where dir1 to dirN are the directories to open. Each directory will be opened in its own tab.

Bug fixes:

  • Newline characters which are embedded in comments for an item in details view have been replaced with a space.
  • Virtual folders now have their friendly name shown in the title bar when the program is configured to show full directory paths.
  • Fixed drag selection bug.

Misc:

  • The display window can no longer be resized to zero height.

(16/06/2008)

Bug fixes:

  • Minor internal bugs fixed.

(10/06/2008)

Bug fixes:

  • Greater amount of internal error checking added.

Misc:

  • New tabs opened with the middle mouse button are no longer switched to automatically.

(08/06/2008)

New features:

  • Tabs can now be closed with the middle mouse click button.
  • Folders can now be opened in a new tab by clicking on them with the middle mouse button.

Bug fixes:

  • Fixed slight bug with tab selection when a tab is closed.
  • Sometimes when a folder was created, it would be inserted into the treeview twice. Fixed.
  • Fixed slight problem involved with swapping tabs.

Misc:

  • Changed main window title from 'Explorer++ - Current directory' to 'Current directory - Explorer++'.
  • Display window can now be vertically resized.

(06/06/2008)

Bug fixes:

  • Greater amount of error checking added to treeview control.
  • Minor treeview collapse selection bug fixed.
  • Bug associated with setting column data in details view fixed.
  • In options dialog, in the default settings tab, setting the details radio button had no effect on the state of the apply button. Fixed.
  • Fixed small bug where program could crash as a tab is closed (would only happen under very specific circumstances).

(05/06/2008)

Bug fixes:

  • Display window now redraws its gradient background as the main window is resized.
  • For items in the my computer folder which have no comment, no comment text is shown in details view (previously a random series of characters was shown for an item with no comment).

(04/06/2008)

Bug fixes:

  • Fixed treeview updating bug relating to folder renaming.
  • Minor sorting bug fixed.
  • Fixed bug relating to the collapse state of treeview items when a folder is deleted.
  • Slight alteration made so that the copying files dialog is now shown during a paste files operation.
  • Changed copy and cut on context menu so that they are handled internally, rather than by the shell.

(03/06/2008)

New features:

  • Added 'Open in New Tab' to right click menu for folders.

Bug fixes:

  • Fixed bug where delete file permanently on File menu was only sending files to recycle bin.
  • Preview images were only been shown for images with a lower case extension. Fixed to be case insensitive.
  • Fixed thread synchronization bug, which would sometimes cause the program to hang.

(02/06/2008)

Bug fixes:

  • Fixed small bug relating to directory monitoring/updating.
  • Fixed problem with options not been applied in Tools/Options general tab.
  • Slight modification made to Tools/Show drive information meaning it may no longer crash. Information shown may be incorrect though.

(01/06/2008)

  • * INITIAL RELEASE *


Navigation - Main

Explorer++ Help Navigation

Click or Hover on an item for more ...


Navigation/File Menu

Click or Hover on an item for more ...


File/ New Tab

This function creates a new tab in the files pane. The tab is always created:

  • as the last tab (far right) - default, or
  • next to (right of) the current tab

depending on the setting in Options.. (Tabs). The contents default to the current setting for same - see Default new tab folder option. The new tab automatically receives the focus (ie. becomes the active tab).

Tip: This function - opening a new tab - is also available by:
  • using the middle mouse button while hovering over
    • a folder in either the treeview or files pane
    • a drive on the Drives toolbar
    • an item on the Bookmarks toolbar
  • selecting New Tab (default contents) or Duplicate Tab (focus not transferred to new tab) from the tab's context (ie. right-click) menu
  • selecting Open in New Tab from a folder's context (ie. right-click) menu in the files pane, or from a button's context menu on the Bookmarks toolbar
  • pressing Ctrl+Enter while a folder in the files pane is selected
  • using Ctrl+doubleclick while hovering over a folder in the files pane
  • double-clicking empty space in Tab bar (default contents)
  • clicking the Create a new tab button (if visible) on the Main toolbar
  • selecting New Tab from a Windows 7 jump list (available as a context, ie. right click) menu from the Task Bar

The above methods, unless stated otherwise, open the tab with the contents of the folder used, not the default contents or Default new tab folder (see above).

Windows 7 Jump List

Screen capture courtesy of David Erceg - thanks!


File/Close Tab

This menu item closes the current tab in the file pane. Currently, there is no way to reopen a closed tab (ie. undo the closing operation), except using normal methods for a new tab.

Info: Starting with version 1.2, closing the last tab can close Explorer++, as an option.


File/Clone Window

This operation opens a new Explorer++ window (instance), complete with all settings and panes copied from the original window. Clone Window only clones the active tab; other (non-active) tabs are ignored.

Clone Window obeys the setting of the Allow multiple instances option; if multiple instances are not allowed, then only a new tab is created and duplicated.

Info: Some settings (eg. column widths in the files pane) may not be duplicated.


File/Save Directory Listing...

This menu item performs a simple directory (folder) listing and saves it as a text file. A Save As Windows dialog allows the user to save the file in any location, under any name.

The listing only contains file/folder names, sorted in alphabetical order; folders are identified with "(Folder)" appended. Note that the file is saved in Unicode format (codepage = UTF-16 LE), with a BOM (byte order mark = FFFE hex) header. Windows Notepad can read this file format and can save the file is ANSI format, if desired.

A small sample file may be found here.

Tip: More detailed lists can be obtained by opening a Command Prompt window and using the Dir command.
Example: dir /ogn > "Directory Listing.txt"
Type: dir /? for help on the Dir command.


File/ Show Command Prompt

This menu item opens a command prompt (ie. DOS box) in the current directory. Executing command line commands can perform some tasks quickly and easily. Note that this opens a 32 bit (ie. cmd.exe) window rather than a 16 bit (ie. command.com) window.

Info: For more information, search the Windows internal Help and Support for "command shell" and "command line reference".


File/Copy Folder Path

This function places the full (ie. fully qualified) path to the current folder - whose contents are shown in the files pane - on the clipboard, for pasting into another application. This may be useful for pasting into text or word processing documents. This is equivalent to

  • selecting the path shown in the address bar, then
  • copying that to the clipboard, using the context menu, or Ctrl+C.

The folder path is copied to the clipboard as Unicode text (ie. plain text) - the clipboard contents cannot be use to paste the actual folder or its contents. Because this is a Unicode copy, foreign characters, such as the Beta in the example, are represented correctly. If Asian characters are included, your Windows system must have support installed for "East Asian Languages" (Control Panel/Regional and Language Options). In order to save true Unicode information, pasting must be done into a text editor which is Unicode compatible, like Windows Notepad.

Example:

H:\Projects\Explorer++\html\mnu_file\New ß Folder

Info: Using this function on a virtual folder (eg. My Computer, not really a true directory) copies the path as a special registry path or GUID (globally unique identifier) - not the path as shown in the Address Bar.


File/Copy File Paths

This function places the full (ie. fully qualified) paths to all currently selected files - as shown in the files pane - on the clipboard, for pasting into another application. If multiple file paths are selected, the paths are delimited (ie. separated) by carriage-return/linefeed characters; pasting multiple files to a text document pastes them as separate line.

File paths are copied as Unicode text - see here for more comments.

Folder paths, ie. selected folders displayed in the files pane, are copied the same as files.

Example:

yields...

H:\Projects\Explorer++\html\mnu_file\New Folder
H:\Projects\Explorer++\html\mnu_file\clone_win.htm
H:\Projects\Explorer++\html\mnu_file\close_tab.htm
H:\Projects\Explorer++\html\mnu_file\copy_col_text.htm

Info: Network resources - files, folders and printers, etc. on a network - are copied using UNC rules, rather than fully qualified paths on the local computer.


File/Copy Universal File Paths

This menu item behaves nearly identically to Copy File Paths, except that the paths to Network resources (ie. files, printers, etc.) are always copied obeying Windows UNC (Universal Naming Convention) rules.

UNC syntax for Windows systems has the generic form:

\\ComputerName\SharedFolder\Resource, or
\\Server\Volume\File

A sample listing (1 file) might look like

\\Netbook\SharedDocs\My Pictures\Josh & Penny - house\IMG_0595.JPG


File/Copy Column Text

The files pane displays file and folder information in columns, such as:

The Copy Column Text function copies to the clipboard (as plain, Unicode text)

  • column headings and
  • the text shown in each column, whether visible or not

for files that are currently selected. Copied text may be pasted into another application, such as a word processor or text editor, using Paste (Ctrl+V) from within that application. Text columns are delimited by tab characters (09h), but columns may not line up in your word processor or text editor, depending on the length of text in each column.

Example:

In the image above, using this function copies the following text to the clipboard:

Name Type Size Date Modified
about.png PNG Image 14.8 KB 8/4/2010, 9:44:56 PM
about-sample.gif GIF Image 247 bytes 8/6/2010, 10:31:02 AM


File/Set File Attributes...

Click or Hover on an item for more ...

This dialog allows the user to change the file attributes, including system time stamps, of selected files and folders.

Change date manually

You may select each of the three fields (month/day/year, shown here), then type a new value. For example, selecting the day field and typing 23 changes the day to the 23rd of the month shown.

Caution: The individual fields may not be the same as shown here - they are determined by the setting for Short date format, found in the Control Panel / Regional and Language Options applet. You may open the Control Panel applet here: - select Customize, then Date tab for the current setting.

Calendar tool

The calendar tool allows you to quickly select a date. You may
  • click any day of the month to select the day
  • cycle through months by clicking the left/right buttons
  • click the month (eg. August) for a drop-down list of months and select one
  • click the year (eg. 2010) for a spinner control to adjust the year
  • click the Today: line at the bottom to select Today (ie. today's date)

Change time manually

As with the manual date change, you should select a field, then type a new value. Type "A" or "P" to change to AM or PM.

Attributes

The checkboxes may be checked (set attribute) or cleared (clear attribute) to affect the following attributes:

Archive | The archive attribute is used to determine whether a file or folder has been changed. Whenever a file (not folder) is created or saved, the archive attribute is set. Most backup programs may be configured to clear the archive attribute as files are backed up.
Read-only | This attribute marks a file or folder to prevent overwriting or deletion. Obeying the status of the Read-only attribute is the duty of individual programs using those files; some may ignore any read-only status. In general, the Windows system will warn you before doing deletion or overwriting of Read-only files.
Hidden | Assigning the hidden attribute flags a file or folder to prevent it from being shown during normal file listings, providing Explorer++ (or Windows Explorer) is not set to view hidden files. Command line operations (eg. Dir) also obey the setting of the hidden attribute.
System | Windows tries to protect system files (necessary for system operation) in a number of ways, one of which is to assign the system attribute. When this attribute is applied, some operations will respect it and alter their function, ie. refuse deletion. In most cases, this behavior can be over-ridden. Windows can also set the Hidden attribute on a system file, making it superhidden.
Indexed | Starting with Windows 2000, the indexing service creates indices of files for speed up of searches. With this attribute set, the file is marked for inclusion in the index.

Info: The Date Accessed (or Accessed date in the dialog) attribute may be considered to be unreliable as:
  • it is not present on FAT16 file systems,
  • has no time component (ie. resolution of 24 hours) on FAT32 file systems,
  • may not be transferred correctly from system to system, and
  • may not be enabled on systems running Windows XP. See here for a tip on enabling this feature.

The Indexed attribute is not supported by FAT16 and FAT32 file systems.


File/ Delete

This function deletes - with a confirmation dialog - selected files and folders. Deleted items are sent to the Windows Recycle Bin and may be recovered from there, if necessary.

Read-only files or folders are deleted as usual, but are identified as read-only by the dialog; if a read-only file is among the selected files (not read-only) it will require an additional confirmation.

System files receive a similar warning, but may still be deleted (probably not a good idea!).

Info: Files deleted from removable drives (eg. flash or jump drives are not sent to the Recycle Bin but are deleted permanently by Windows. Not all USB drives are considered removable drives; some larger drives install as local drives. Viewing the properties for a drive in the Folders pane will identify it as Local (fixed) or Removable.


File/Delete Permanently

This menu item deletes selected files and folders, but does not send them to the Windows Recycle Bin. This is not a secure delete; see Destroy File(s)... for secure deletion of files.

Info: Files and folders deleted by Windows are not really removed (immediately) from the file system. Instead, the File Allocation Table (FAT16 and FAT32 file systems) or Master File Table (NTFS) is marked indicating that the file has been deleted, and its entry is cleared. The disk space occupied by the file is declared free for use, but the actual file data is not immediately removed. It can, however, be over-written; once that occurs, the file is usually unrecoverable, except possibly in part, by recovery utilities such as Recuva, a freeware product by Piriform.


File/ Rename

This routine is really two routines in one, depending on whether a single file (or folder) is selected or multiple items are selected.

Single item

Explorer++ allows you to edit the name in an in-place edit box, keeping the extension the same. The extension may be edited, but must be deleted then re-typed or selected then over-written.

Tip: Pressing F2 during a single item rename cycles between highlighting

  • the file name

  • the file extension

  • the full name, including the extension

Multiple items - Mass Rename

The Mass Rename dialog allows you to build a new name for all files selected using alphanumeric characters, combined with special character combinations or words. The special words are visible in a reminder box by clicking the arrow button to the right of the Target pattern: edit box. Note that special words are case-sensitive and any characters that do not form a special word are placed in the new filename as-is.

/F | resolves to the entire filename, as originally named. Same as /B/E
/B | resolves to the filename minus extension, example: for "about_help.htm", /B resolves to "about_help"
/E | resolves to the file extension, including " . ", example: for "title.htm", /E resolves to ".htm"
/N | resolves to an integer, beginning with 0 for the first file

Typing the new file name pattern into the edit box shows the new files previewed to the right of the existing names. Clicking OK completes the rename operation.

Info: Undo works on the entire list as a set; all files renamed by a Mass Rename as restored to their original names.


File/ Properties

This function opens the Windows property sheets for the file or group of selected files. Property sheets may vary, depending on your configuration, and whether additional utilities are installed, but in general should show information such as:

  • Type of file: as recognized by Windows, eg. Text document (.txt), PNG image (.png), etc.
  • Opens with: an application associated with the file, if any
  • Location: folder containing the file
  • Size: and Size on disk: actual file size (of contents, if folder is selected) and disk space used
  • Contains: number of files and folders contained in a folder (if a single folder is selected only)
  • File attributes currently applied
  • Security settings and permissions (NTFS only - may not be shown, depending on system settings)
  • File Summary: comments, if any assigned to the file by the user or an application (NTFS only)
  • Customize: allows you to change certain properties (eg. image, icon) of a folder or group of folders

Utilities such as Hashtab (which displays hashes for the file, such as CRC32 and MD5) may introduce additional property sheets.

If multiple files are selected, many of the same properties are shown, including Size: and Size on disk:, which now refer to the collective size of all the files selected.

The Properties function is also available as part of the context (ie. right-click) menu in the folder or files panes.

Tip: The Properties dialog can also be activated by Alt+doubleclick while hovering over a file or folder.


File/Exit

This menu item exits Explorer++. Prior to closing, Explorer++

  • saves settings to an XML file (config.xml) in the same folder as Explorer++.exe, or
  • saves settings to the Windows registry,

depending on the setting for portable mode.

The window close button - [image] - and closing the last remaining tab in the files pane (subject to an option), perform the same operations as Exit.


Navigation/Edit Menu

Click or Hover on an item for more ...


Edit/ Undo

This function allows you to undo a single file or folder renaming operation, restoring the original name. When renaming multiple items using the Mass Rename dialog, all items can be undone as a single operation.

Caution: Explorer++'s Undo cannot undo a file cut, move or delete.
Info: Renaming a folder which has been bookmarked does not automatically rename the bookmark.


Edit/ Cut

The Cut operation removes selected files and folders and places them on the clipboard, for pasting in a different location. Cut may be used from the files or folders pane.

Items to be cut are still in their original location - they are only marked for cut - until pasted, at which time the originals are removed. Items cut are not placed in the Recycle Bin; they are deleted permanently from their original location after pasting.


Edit/ Copy

Copy places selected items (files and folders) on the clipboard for subsequent pasting. The clipboard's contents may be pasted into the source folder; copies of all items are created.

Copy does not delete the original files or folders.

Info: Copying (and Pasting) files or folders from other locations (ie. not the same folder) detects collisions (duplicate names) and presents the usual dialog allowing replacement, if desired. Files or folders copied from the same folder are renamed - Copy of..., Copy (2) of..., etc.


Edit/ Paste

This menu item takes data from the clipboard and pastes it into the files pane, or the folders pane if it has the focus. If files or folders were cut in order to place them on the clipboard, then they are deleted at this time. Explorer++ handles various types of data, and the pasting method, differently, according to the following table:

Clipboard data

Paste method

Result

files/folders | paste into blank area of files pane | files/folders pasted normally to location of the files pane
files/folders | paste into folders pane (using menu item, or toolbar button) | files/folders pasted into the folder having the focus in the folders pane. New files/folders will, of course, appear in the files pane (contents of focused folder).
text | paste into dialog, or rename file operation | text inserted, or overwrites text selection
text paste into blank area of files pane text pasted as new text file, automatic naming:
eg. Clipboard Text (10-20-2010, 6.44.01 PM).txt
text | paste into folders pane (using menu item, or toolbar button) | text pasted as new text file (as above) into the folder having the focus in the folders pane. New file will, of course, appear in the files pane (contents of focused folder).
bitmap
(image) 		image data, copied from a paint program, for example is pasted into blank area of files pane new image created, automatic naming:
eg. Clipboard Image (10-20-2010, 6.53.48 PM).bmp
New image always created as Windows bitmap, regardless of original image type.

See Copy for a discussion of behavior when file names are duplicated.


Edit/ Paste Shortcut

This menu item pastes Windows shortcuts to the files and folders currently on the clipboard, in the current folder as shown in the files pane. The files and folders would have been placed on the clipboard by Copy or Cut. If Cut was used, then pasting shortcuts does not delete the original file, as with Paste.

About Shortcuts

Shortcuts are small files (typically < 1000 bytes) - always with the extension .LNK - which contain, among other things, the path to a file or folder. A shortcut file behaves, for the most part, the same as the file it references. That is,

  • double-clicking a shortcut (or .LNK file) opens the target file
  • using a context (or right-click) menu to Edit a shortcut, opens the target file for editing
  • etc.

Creating shortcuts using this function always creates a .LNK file with the fully qualified path (eg. C:\folder\file.ext) used, rather than a relative path (eg. ..\..\folder2\file2.ext), and may, therefore, be moved anywhere on the local computer and will still function correctly.

Since shortcuts are true files and only link to the target through a (text) path, deletion or modification of a shortcut has no effect on the target file.

A good use for shortcuts is to place in one location (ie. one folder) a collection of shortcuts to files which are related in content or purpose, but which are scattered over the whole computer.

Shortcuts may be edited by using the Properties function. Typically, the user may change

  • the shortcut's name. When created, it has the same name as the target file, but this is not necessary.
  • the application used to open the target file
  • the shortcut's (not the target file's) attributes
  • the target file, working folder (if any) and hotkey (if any)
  • the shortcut's icon (default is the icon of the target file)
  • security settings (ownership, permissions, etc.), if implemented (NTFS drives only)

Shortcuts may be created (by other means, such as <right-click>Create Shortcut) to Windows special folders, such as Control Panel, which are not true physical folders. The target for these types of shortcuts is usually not editable. Also, installation of some applications may create shortcuts to those applications which are not editable.


Edit/Paste Hard Link

This menu item pastes Windows hard links to the files currently on the clipboard, into the current folder as shown in the files pane. The files would have been placed on the clipboard by Copy or Cut. If Cut was used, then pasting shortcuts does not delete the original file, as with Paste. Note that folders cannot have hard links.

About Hard Links

Hard links are a feature of the NTFS file system (ie. not available on FAT16 or FAT32 drives) which allows creation of virtual files which point to a true file. Multiple virtual files may point to the same file, with each behaving as though it were the true file. The hard link points to the MFT (Master File Table) entry for the true file and propagates changes to the entry (except for the file name) to all other hard links pointing to the same file.

The following diagram may explain this concept better, but may not be completely accurate in its representation of the MFT entry or file structure.

In the diagram, the original name points to (and accesses) an MFT entry which contains all file attributes (timestamps, read-only flag, etc.) and in turn points to the actual file data. When the hard link is created, it points to the same MFT entry, but could have a different name. The Explorer++ function - Paste Hard Link - always creates the hard link with the original file name; obviously, then it cannot be created in the original folder or else a naming conflict will exist. Since the original name and hard link name use the same MFT entry, etc., changes to either file result in changes to the true file data and attributes; the newly created hard link file is essentially a true file! To remove a hard link, deleting either file name has the same effect; the remaining (single) link becomes the true file.

In Windows, the NTFS file system counts the original name as hard link #1 and the additional hard link as #2; all normal files, then would have a hard link count of 1. The file system tracks the hard link count for each file at all times; when the count becomes 0, then the file data area is considered free space and may be reclaimed. It is interesting to note, therefore, that when a file is deleted (to the Recycle Bin), it would still have a count of 1 since only the name (and MFT entry?) have been removed. It is not until the Recycle Bin is emptied that the file is completely deleted, assuming its hard link count was 1, ie. no additional hard links to the file exist.

Hard links may only be created for files on the same volume (ie. the same drive letter); attempting to paste a hard link to a file on a different volume results in a true copy of the file.

Explorer++ can view the hard link count by enabling Hard links as a column heading in the files pane.

If you use hard links frequently, you might consider a useful freeware tool - Link Shell Extension - which can manage hard links. When installed, it (among other things) creates an additional property sheet which allow enumeration (ie. location) of any additional hard links to a file, something that Windows can't do!

Info: Hard links may also be created by the Windows command line tool Fsutil (Windows XP) or Mklink (Windows Vista or later).


Edit/ Copy To Folder

This menu item copies selected files and folders to a different location. After selecting the files/folders and selecting this item, the user is presented with a standard Browse for folder dialog (see tip for a picture of this Windows dialog), allowing the destination location to be chosen.

Using this function is the same as a Copy/Paste operation, but without changing tabs or folders on a tab.


Edit/ Move To Folder

This menu item moves selected files and folders to a different location. After selecting the files/folders and selecting this item, the user is presented with a standard Browse for folder dialog (see tip for a picture of this Windows dialog), allowing the destination location to be chosen.

Using this function is the same as a Cut/Paste operation, but without changing tabs or folders on a tab.


Edit/Save File Slack...

This function recovers a single file's slack space and saves it to a (text) file using a standard Save As dialog. Multiple files may be selected, but the resulting file slack file is usually not useful or complete. In some cases, this may help recover lost data which has been overwritten, but the user should not rely on this. Saving file slack as a text file may still result in some binary (eg. non-text) data.

See below for more information on file slack.

About File Slack

When Windows formats a hard disk, it uses the disk capacity to determine a cluster size - the minimum unit of disk space available for file storage. In most cases on NTFS file systems, this will be 4 kilobytes or 4096 bytes. This means that as file space is allocated to a saved file, the actual space used is stepped in 4 kilobyte increments. A 2 Kb file, for example, would still use (at least) 4 Kb of disk space. Checking a file's properties, shows that in every case (?) the size on disk is larger than the actual file size. Some of this disk space used is for attributes, security/permissions, etc., but in most large files, the majority of space is dedicated to actual file data.

But not all...! Since files - unless the size of data + attributes, etc. exactly equals a multiple of sector size - use disk space in 4 Kb increments, it is usual that some empty space in disk clusters exists. That empty space is not assigned to file data, or to attributes, security concerns, etc.; it is just wasted space and usually contains data left over from previous files which occupied the same clusters, or simply random memory bytes which were written with the file. That empty space (ie. file slack) could contain data placed there intentionally by malevolent programs, or could be used to hide data by the user. Programs such as Slacker can hide files within a file's slack space; interesting, but not a good idea unless you are sure the file size will not change or the file be erased.

The concept of file slack forms an important part of computer forensics - analysis of computer data for legal evidentiary purposes. An interesting short video on the possible use of file slack to learn more about a computer user can be found here on YouTube.


Edit/Resolve Link

This function resolves (ie. locates) the target file (or folder) of a single selected shortcut. A new tab is opened and the target file is selected. Locating the file/folder in this way is usually considerably faster than navigating to the target manually.

If the target cannot be located, for example, if it has been deleted, a Windows error message is displayed which allows you to locate the target file.


Navigation/Selection Menu

Click or Hover on an item for more ...


Selection/Select All

This function selects all files (and folders) in the files pane as shown in the current tab.

Info: Individual files may be deselected, after using Select All, by using Ctrl+click_on_file. In Details view, the file must be clicked in the first column, unless the Full row selection in details view option is enabled.


Selection/Invert Selection

Using this function affects the files or folders in the files pane, causing

  • selected files to be deselected, and
  • deselected to be selected.

In other words, it inverts that state of selection for all contents of the current tab.


Selection/Select All Of Same Type

This function selects all files in the folder of the same type as the one currently selected. For example, if the files pane (ie. currently folder) shows multiple types of images, ie. gif, png, jpg, bmp, etc., it is possible to select only jpg images by

  • select a single jpg image, by clicking on it
  • use this function - Select All Of Same Type.

The end result is that all jpg files will be selected.

Tip: Select All of Same Type uses the file type, as determined by the Windows registry - not the file extension! This means, for example, that image1.jpg and image2.jpeg will both be selected, since they are both of type JPEG Image. Windows file types may be viewed by enabling the Type column in the files pane. You may select by file name using the Wildcard Select... routine.


Selection/Select None

This menu item deselects all files (and folders) in the files pane, ie. current tab.

All files may also be deselected by clicking in a blank area in the files pane, in the first column (usually Names) or clicking in any other column.

Info: Individual files may be selected, after using Select None, by using Ctrl+click_on_file. In Details view, the file must be clicked in the first column, unless the Full row selection in details view option is enabled.


Selection/Wildcard Select...
This menu item allows the user to select files in the files pane (ie. current folder) using a wildcard pattern. A dialog is opened which allows the user to enter a new wildcard pattern, or use the drop-down button and choose a previously used pattern. Clicking OK selects files and folders based on that pattern. Repeated use of Wildcard Select... is cumulative; additional files may be selected, adding to the current selection.

Unlike Select All Of Same Type, the selection process is based on file name and extension.

About wildcard patterns

A wildcard pattern is a file specification which contains symbols representing unknown characters, as well as ordinary alphanumeric characters.

The two wildcards available here are:

* (asterisk) this character substitutes for zero or more characters. Some examples are:
*file.txt matches "somefile.txt", "my_file.txt", but not "my_files.txt" (intervening "s" prevents match).
btn*.* matches "btn_23.png", "btnumbers.txt" and "btn-img.jpg", but not "mybtn.jpg" (leading "my" prevents match) or "btn12" ("." specified must exist)
? (question mark) this character substitutes for any single character, which must exist. Some examples are:
final?.doc matches "final1.doc", but not "final_chapter.doc" (? matches only 1 character, "_chapter" is not 1 character)
file.tx? matches "file.txt", but not "file.tx" (last wildcard character must exist)


Selection/Wildcard Deselect...

This menu item allows the user to deselect files (already selected) in the files pane (ie. current folder) using a wildcard pattern. A dialog is opened

which allows the user to enter a new wildcard pattern, or use the drop-down button and choose a previously used pattern. Clicking OK deselects files and folders based on that pattern. Repeated use of Wildcard Deselect... is cumulative; additional files may be deselected, reducing the current selection.

Wildcard Deselect... deselects files (and folders) based on file name and extension.

See Wildcard Select... for examples of wildcard patterns.


Navigation/View Menu

Click or Hover on an item for more ... (see below for alternate menu)
Windows Vista and 7 may present slightly different menus...

Windows Vista / 7

Screen capture courtesy of David Erceg - thanks!


View/Status Bar

Click or Hover on an item for more ...

The status bar presents some quick information and may be toggled on/off from the View menu.

Items/text

This area shows either

  • the number of items (files and/or folders) and displays one of the following:
    • if no selection exists - total item count (eg. 24 items), a count of items in the folders pane (current folder)
    • if a selection exists - total selection count, the number of items selected, or
  • the helper text of a menu item when the mouse is hovered over that item.
    Example: hovering over the File/New Tab menu item displays "Creates a new tab".

Size

This area shows the actual item (files and/or folders) size and displays one of the following:

  • if no selection exists - total file size, the combined size of all files in the folder. Note that folder items are not included in this size, even if the Show folder sizes option is enabled.
  • if a selection exists - total selected file size, the combined size of all selected files (not folders)
  • if the current tab is a virtual folder (ie. special Windows folder) - the words Virtual Folder. Selecting items has no effect.

If a real size is shown (not a virtual folder), then the size is affected by the Show all file sizes in:... setting.

Free space

This area shows free disk space for the volume which houses the currently active folder (files pane). Free space is shown in bytes (rounded to MB, GB, etc., regardless of any options settings) and in percentage of the entire volume.


View/Folders

This menu item toggles the visibility of the Folders pane. When the Folders pane is hidden, its former window area is used by the Files pane, allowing more columns (or wider columns) to be displayed.

Toggling the visibility of the Folders pane may also be done through a button on the Main toolbar.


View/Display Window

This menu item toggles the visibility of the Display Window. The Display Windows presents some additional information about selected files.


View/Toolbars

View/Toolbars ►

Click or Hover on an item for more ...

About toolbars

For general information about Explorer++'s toolbars, ie. moving, resizing, customizing, etc., see the toolbars Overview.


View/Views

The Files pane may present files and folders using a variety of display methods. Each has its own merit, depending on the content being displayed, and may display different amounts of file information.

Views may be also accessible from a button on the Main toolbar.

Info: In most views, the name may appear to be the primary display item. Actually, it the leftmost information column (as shown in details view) which is displayed! In icons view, for example, the file size could be displayed instead. See Select Columns... for more information.

Thumbnails

This view displays thumbnail images for each file. Using Thumbnails is primarily useful when displaying images; other files may simply display a generic image assigned by Windows.

Explorer++ presents a view of each folder, as well, showing a few thumbnails of images (if any) contained therein.

Currently, the thumbnail size is fixed (internal to Explorer++) at 120x120 pixels. Explorer++ does not cache thumbnails as Windows Explorer does (optionally creates "Thumbs.db" file).

Tiles

Tiles view displays the files and folders, using the Windows generic images for file types. In addition, the file type and size is displayed.

Files and folders are displayed in a manner similar to Thumbnails - in as many columns as the width of the Files pane will allow.

Icons

Icons view uses embedded (resource) icons from files and, as with Thumbnails and Tiles, displays the files and folders in columns, as space allows.

Icons view is perhaps better suited to displaying executable files, and icon files (of course). Icons are displayed in 32x32 bit size.

Note: Windows Vista / 7 presents 4 different sized icons for View choices.

Small Icons

The Small Icons view is similar to Icons view, but the icons are displayed in 16x16 bit size allowing more files/folders to be displayed in the same space.

Note: Windows Vista / 7 presents 4 different sized icons for View choices.

Bug: The Small Icons view currently has some acknowledged deficiencies in layout behavior.

List

List view displays files using generic icons and a single piece of information, usually the file name (see above). Items are displayed in columns to fit the available space.

Details

The Details view shows textual information and generic icons, in a single vertical list. It can display multiple columns of information, as set by the user.

This display method can yield the most information, but usually takes up the most pane width. Columns not displayed due to lack of pane width may be scrolled into view as needed.

Items displayed in this view may be re-arranged using drag-and-drop. This has no effect on their actual order in the folder, but may aid the user in selections, editing, etc.


View/Auto Arrange

When displaying items using the Thumbnails, Tiles, Icons or Small Icons methods, items are normally displayed in orderly columns, laid out according to available width in the Files pane. Checking the Auto Arrange menu item enforces this requirement.

When Auto Arrange is unchecked, items may be dragged to positions outside the columns allowing the user to visually organize the pane to his liking. This is not a permanent re-ordering; the effect is merely visual.

If the view is changed, for example from Thumbnails to Icons, the items are initially organized in columns even if Auto Arrange is not enabled.

The following image demonstrates what can be done with Auto Arrange turned off (disabled).

On

Off


View/Sort By

View/Sort By ►

Click or Hover on an item for more ...

This menu selects a sort order for display of files and folders in the Files pane.

Selecting a Sort By order cancels a Group By order. The Sort By menu is built by Explorer++ based on the columns currently enabled in Details view; your menu may differ from the one shown here. Selecting an item in this menu has the same effect as clicking on the header for that column in the Files pane.


View/Group By

View/Group By ►

Click or Hover on an item for more ...

This menu selects a sorting order and grouping for display of files and folders in the Files pane.

Selecting a Group By order cancels a Sort By order. The Group By menu is built by Explorer++ based on the columns currently being displayed in Details view; your menu may differ from the one shown here.


View/Show Hidden Files

Clicking on this item toggles display of hidden files - on or off. Hidden files are those which have the hidden attribute set; they are usually masked from display if marked as hidden. This setting can be changed on a tab-by-tab basis; new tabs are created with this setting enabled.

In the Files pane (only), hidden files and folders are displayed with their accompanying icons ghosted (ie. washed out).

The Control Panel/Folder Options/View setting - Show (Do not show) hidden files and folders - has no effect on display of hidden items (see tip); Explorer++ controls hidden visibility for itself.

Tip: System files and folders may be superhidden - that is, they have both the Hidden and System attribute set - and are not displayed, even if Show Hidden Files is checked. To allow superhidden files and folders to be affected by this function, you must uncheck the "Hide protected operating system files" setting in the Files and Folders tab of Explorer++'s options.

Display of superhidden files is contingent on a Windows system setting being enabled; you must uncheck the "Hide protected operating system files" setting in the Folder Options applet (View tab). The Folder Options applet is found in the Control Panel. A custom tool found in Appendix A may be quicker for making this change. Note that Explorer++ can control visiblility of ordinary hidden files (Hidden attribute, but not System attribute) without enabling the "Show hidden files and folders" option in the Control Panel.


View/ Refresh

In the Files pane, all files (depending on Explorer++ setup) are displayed and sorted. Using Refresh updates the display; the files are re-sorted and re-displayed, subject to current settings (ie. Sort By, Group By, Show Hidden Files, etc.).

Refresh also restores the address of the currently active tab in the Address bar.

Info: The Folders pane is not refreshed (ie. rebuilt) by Refresh. Collapsing (clicking the minus, eg. ), then expanding (clicking the plus, eg. ) for a node in the Folders pane will refresh that node.


View/Select Columns...

Click or Hover on an item for more ...

Explorer++ allows you to set data column visibility for folder listings on a tab-by-tab basis. Columns available also depends on the current tab's folder type. The settings here apply only to the current tab; future (new) tabs adopt the settings from the Default Columns... setting.

For more information about column settings, see here.

Columns available

This area shows the list of columns available for the type of folder currently being viewed; checking the checkbox beside the name enables the column in the Files pane. This list of available columns may vary with the type of folder currently being viewed (ie. the active folder for a tab). In addition, while a particular column may be checked, not every file in the folder may possess the type of data placed in that column. For example, image files may show data in the Width and Height columns, but text files will not. In addition, the columns is different for virtual folders, etc, as outline in the lists following.

Column Order

Columns are displayed (left to right in the Files pane) in the order shown, from the top down. The order may be changed using the Move Up and Move Down buttons.

Folder type

Folder type/name | Comments
Control Panel | Windows virtual folder: a collection of applets for modifying your system, etc.
General | This is a normal (ie. real) folder on your system. This type of folder comprises 99% of what you will view and presents, therefore, the most common list of columns.
My Computer | Windows virtual folder: shows volumes (ie. drive letters) and some other virtual or system folders, such as My Documents, Control Panel, etc.
Network Connections | Windows virtual folder: This is actually the Control Panel applet which manages connections.
My Network Places | Windows virtual folder: network configuration tools, and Entire Network (access to network computers and devices).
Printers and Faxes | Windows virtual folder: list of printers, faxes and printer drivers connected to your system.
Recycle Bin | Windows virtual folder: collection of erased files which are still recoverable.

Following is a list of all columns available for the different types of folders which can be viewed. Default columns (with a checkmark in the Def column) and default column order, assigned by the system (ie. order, left to right) ,are also shown. The user may change the default widths (always 150 pixels) through the Save Column Layout as Default menu item.

Incomplete: Columns marked as "n/a" (not available) may not be implemented as of this version of Explorer++, ie. they may be present but contain no data.

Control Panel

Def | Column | Description
1 | Name | applet name
2 | Comments | brief description of applet's purpose

General (real File or Folder) - not all tags apply to all file types

Def | Column | Description or Comment
1 | Name | file or folder name
2 | Type | Windows associated descriptive file type
3 | Size | file size or folder contents size (if enabled)
4 | Date Modified | date of last file/folder modification. Some applications may modify the file without changing this attribute.
 | Attributes | common file attributes
 | Size On Disk | amount of disk space used by file - see here for more
 | 8.3 Name | file name in older (ie. DOS) 8 character name, 3 character extension format
 | Owner | Windows security - owner of file or folder
 | Product Name | executable - from Version property sheet
 | Company | executable - as above
 | Description | executable - as above
 | File Version | executable - as above
 | Product Version | executable - as above
 | Shortcut to | target of shortcut (.LNK or .PIF) file
 | Hard links | number of hard links associated with this file - see here for more
 | Extension | file extension (minus dot)
 | Date Created | date of file or folder creation
 | Date Accessed | date of last access (read or write) of file or folder. On Windows XP this may only reflect the nearest hour. Also see tip below.
 | Title | user supplied - title of file - entered in Summary property sheet
 | Subject | user supplied - subject of document - entered in Summary property sheet
 | Author | user supplied - author of document - entered in Summary property sheet
 | Keywords | user supplied - associated key words - entered in Summary property sheet
 | Comment | user supplied - comment - entered in Summary property sheet
 | Camera Model | EXIF data, recorded by camera in an image file
 | Date Taken | EXIF data, recorded by camera in an image file
 | Width | width of image (bits)
 | Height | height of image (bits)
 |  | Note: The following media tags may be associated with audio, video or ? - tagging of media files allows many options!
 | Bit rate | media (audio/video) file - bit rate associated with data
 | Copyright | media (audio/video) file - internal tag identifying file as copyrighted
 | Duration | media (audio/video) file - play time
 | Protected | media (audio/video) file - identifies file as protected media
 | Rating | media (usually video) - internal tag for rating
 | Album artist | media (audio) - internal tag (text)
 | Album | media (audio) - internal tag (text)
 | Beats-per-minute | media (audio) - internal tag
 | Composer | media (audio) - internal tag (text)
 | Conductor | media (audio) - internal tag (text)
 | Director | media (video) - internal tag (text)
 | Genre | media (audio) - internal tag (text)
 | Language | media (audio) - internal tag (text)
 | Broadcast date | media (video) - internal tag (text)
 | Channel | media (video) - internal tag (text)
 | Station name | media (video) - internal tag (text)
 | Mood | media (audio) - internal tag (text)
 | Parental rating | media (video) - internal tag (text)
 | Parental rating reason | media (video) - internal tag (text)
 | Period | media (video) - internal tag (text)
 | Producer | media (video) - internal tag (text)
 | Publisher | media (audio) - internal tag (text)
 | Writer | media (video) - internal tag (text)
 | Year | media (audio) - internal tag (text)

Tip: The Date Accessed timestamp may not be reliable in Windows XP. It is subject to a registry setting - NtfsDisableLastAccessUpdate - which does not exist, by default. To enable automatic updating of Date Accessed, open a command prompt window and execute the following command:
  fsutil behavior set DisableLastAccess 0
Executing this command creates the required registry entry and enables automatic updating of Date Accessed. Updating can be disabled by setting the value to 1.

My Computer

Def | Column | Description
1 | Name | drive name (and letter) or special folder name
2 | Type | Local Disk, CD Drive, Removable Disk, Folder, etc.
3 | Total Size | size available on drive
4 | Free Space | unused drive space available (bytes, GB, etc.)
 | Comments | provided by Windows - folder function, drive details, etc.
 | File System | FAT (ie. FAT16), FAT32, NTFS, Unknown

Network Connections

Def | Column | Description
1 | Name | name of connection, eg. Local Area Connection
2 | Type | n/a (future feature?)
3 | Status | n/a (future feature?)
4 | Owner | n/a (future feature?)

My Network Places

Def | Column | Description
1 | Name | name of tool or applet
2 | Comments | description of tool or applet

Printers and Faxes

Def | Column | Description
1 | Name | device or driver name (descriptive name, not file name)
2 | Documents | number of documents in queue (ready for printing)
3 | Status | Ready, Printing, error status, etc. - driver dependent
4 | Comments | user assigned, or place there by installation
5 | Location | user assigned? network?
6 | Model | brand name, model name

Recycle Bin

Def | Column | Description
1 | Name | file or folder name
2 | Original Location | n/a (future feature?)
3 | Date Deleted | n/a (future feature?)
4 | Size | file size or folder contents size (if enabled)
5 | Type | Windows associated descriptive file type
6 | Date Modified | date of last file/folder modification


View/Autosize Columns

This menu item automatically resizes enabled columns to fit the data shown in the Files pane, including items which must be scrolled into view. Data items should fit exactly (no extra space) and should not be truncated. This operation does not affect other tabs, or newly opened tabs.

Before

After

Info: Autosize Columns is not a one-time option setting - you may need to use this feature on other folders.


View/Save Column Layout as Default

This function saves the current column layout as the default for any future new tabs, but only of the same folder type. The column layout saved includes:

  • which columns are enabled,
  • column order and
  • column width.

Setting the default columns using the Default Columns... option, accomplishes nearly the same thing, but uses the current default column widths rather than the current column widths.

For more information about column settings, see here.


View/Change Display Window Colours...

View/Change Display Window Colors...

This dialog allow you to customize the colors and font of the Display Window. See below for a brief description of the color gradient used as a background.

Click or Hover on an item for more ...

Description of color gradient

The Display Window background is a diagonal color gradient in 2 directions. Think of the Center color as the starting point of the gradient - a single point in the top-left corner of the Display Window ; the Surrounding color is the final color, located in the bottom-right corner. The gradient is drawn diagonally from top-left to bottom-right, but also in a pseudo-complementary (ie. at 90°) direction. The end result is a pleasing diagonal gradient with colors on the left generally close to the Center color and colors to the right generally close to the Surrounding color. The algorithm behind drawing the gradient is not useful; the colors should just be adjusted visually for the best combination.

Center color

The controls for the Center color (ie. top-left corner) allow RGB (Red/Green/Blue) adjustment, either by moving the slider or by entering an integer (0..255) in the edit box to the right of each slider. For a little help with RGB colors, here are some samples:

R | G | B | Common name | Sample
0 | 0 | 0 | black
255 | 0 | 0 | red
0 | 255 | 0 | green
0 | 0 | 255 | blue
255 | 255 | 0 | yellow
255 | 0 | 255 | magenta
0 | 255 | 255 | cyan
255 | 255 | 255 | white

Surrounding color

The controls for the Surrounding color (ie. bottom-right corner) allow RGB (Red/Green/Blue) adjustment, in a manner similar to the Center color.

Restore Defaults

This button restores Explorer++'s built-in defaults for the Display Window, that is

  • Center color = RGB (0,0,0)
  • Surrounding color = RGB (0,94,138)
  • Font = "Segoe UI"
    • height = 10 (approximate - device dependent)
    • weight = 500 (medium)
    • no italic
    • no underline
    • no strikeout
    • default character set
    • high quality output

    Note that the "Segoe UI" font is an included font in Windows Vista and 7; most Windows XP users will not have access to that font and their system will substitute an available font, probably "Courier". A similar font might be

    • Lucida Sans (Bold),

    • Microsoft Sans Serif (Bold),

    • Tahoma, or

    • Trebuchet MS

    but nearly any font may be used.

Choose font...

This button opens a standard Windows dialog allowing the user to choose a suitable font for text in the Display Window. Headings and information text both use this font. See comments in Restore Defaults regarding the font used.

Display Window preview

This area previews the color gradient and text using the selected font. Changes made to the Center color and Surrounding color are previewed, as the changes occur, so that the user may choose the color gradient visually.


View/Filter

View/Filter ►

Click or Hover on an item for more ...

Filtering allows certain files to be masked from view in the Files pane; only the files you specify (and folders) will be visible. This helps find files quickly, particularly in folders which contain a large number of files, such as the Windows folder. Filtering can be applied on a tab-by-tab basis.

Set Filter...
The filter specified is in the form of a wildcard pattern, in a manner similar to Wildcard Select. See here for a description of wildcard patterns. When the pattern is set (by clicking OK), then the filter is applied automatically to the current tab and only those files which are a match for the wildcard pattern are displayed.

The Set Filter... dialog drop-down shows previous wildcard patterns used in filtering.

Apply Filter

This menu item is a toggle which enables/disables filtering; filtering (when enabled) always uses the last set wildcard pattern, as shown on the Set Filter... (Filter Results) dialog.

When filtering is enabled, the following image is present in the center of the Files pane: . If filtering is disabled, the files which are now visible may be placed at the top of the file list; a Refresh may need to be done in order to sort the files.


Navigation/Actions Menu

Click or Hover on an item for more ...


Actions/ New Folder

This menu item creates a new folder in the current folder (tab). The default name is New Folder, but creation of the folder automatically enters rename mode: so that the new folder may be renamed by the user to something more useful.

Creating a new folder inserts it into the file list (Files pane), obeying the setting of Insert new items in their sorted positions.


Actions/Split File...

Click or Hover on an item for more ...

This function provides a useful operation - it splits the selected file into equal sized sub-files. While this may not seem that useful at first glance, many email providers, for example, have a limitation on the size of attachment that can be sent with a single message. If the file is over that size, then the server will automatically reject that message entirely; the file can be split, sent in parts, then re-assembled when received.

The companion function - Merge Files... - restores the original file by combining the sub-files.

Split size:

Enter the split size in the left box; set the units in the right box using the pulldown. Units are determined by the units drop-down list to the right and may be

  • Bytes,
  • KB kilobytes = 1024 (210) bytes,
  • MB megabytes = 1024 KB or 1,048,576 (220) bytes, or
  • GB gigabytes = 1024 MB or 1,073,741,824 (230) bytes.

The final size of the individual sub-files is a combination of the size and units selected.

Output Filename:

The output filename is actually a pattern for consecutive naming/numbering of the output files; the string "/N" (capital N only!) represents the variable numeric part of the future file names (e.g. 1, 2, 3, etc.). The default is <original filename>.part/N, which in the sample dialog above (original file = NB200_D.zip) would create sub-files of

  • NB200_D.zip.part.1
  • NB200_D.zip.part.2
  • NB200_D.zip.part.3
  • etc.

The sub-file naming pattern must contain a variable (i.e. /N) and the numeric variable portion of the new files always starts with 1.

Tip: Be careful with leading zeroes in the output filename; they are treated as constants. For example, using NB200_D.00/N as the pattern yields files NB200_D.001, NB200_D.002 but would also yield NB200_D.0010 instead of the anticipated NB200_D.010! Explorer++'s Merge Files... routine can handle this naming, but other split/join applications may not behave properly.

Output Folder:

The output folder (where the sub-files will be placed) defaults to the same folder as the target file. The folder may be chosen by typing (the target folder must exist) or by using the ... button to the right which opens a standard Browse for folder dialog (see tip for a picture of this Windows dialog).

Split

Clicking the Split button commences the operation, creating sub-files of the specified size. The last file may not be the same size; it is simply the remaining portion of the original file. Files are named the same as the target file, but with a number appended, that is, if message.txt is split, sub-files will be message.txt.1, message.txt.2, and so on.

Info: If Split File... involves creating a large number of files (e.g. > 500), there may be delays in response, depending on the speed of your computer. Be patient - Explorer++ will finish the operations properly.


Actions/Merge Files...

Click or Hover on an item for more ...

This function merges selected files (which were previously split by Split File..., or other utility) into a single file. The merge operation is a simple binary concatenation of the files, in the order shown.

Files to be merged

This area contains the list of files to be merged; the order in which they appear is the order in which they will be merged. The order may be changed through the use of the buttons to the right. There is a good likelihood that - if the files were created by Explorer++'s Split File routine, they will already be in the correct order. Note that the Date Modified column respects the setting of the Show user friendly dates option.

Move Up/Down buttons

These buttons help manipulate the file list by moving the selected file (one only!) up or down in the list. If the files were previously split by Split File..., they should already be in order.

Info: Multiple files may be selected by default, but Up/Down operations only operate on a single file.

Output File:

This edit box contains the path and file name to the final merged output file. The default name is output (no extension); the file will be generated by default in the same folder as the files in the merge list.

Output Folder:

This button opens a standard Windows Browse for folder dialog (see tip for a picture of this Windows dialog), allowing the user to place the output file in a different location.

Tip: The Browse for folder dialog only selects a folder; the user must then add a file name. Failure to add a file name will result in an error.
Example: Browse for folder yields "F:\myfiles\temp",
but user must add "\final.zip" as filename, making
Output File: "F:\myfiles\temp\final.zip".

Merge (or OK)

Clicking Merge (or OK - button text may change) performs the file merge operation, creating a new file. The merge is done using simple binary concatenation without regard for contents. While any set of files can be merged, the Merge Files action is designed to re-combine files created by the Split File action.

Tip: Although individual files may be selected before merging (eg. hold Ctrl key and select random files), this has no effect. All files in the dialog will be merged in the order shown, regardless of any selection.

Errors

If a Merge error occurs, it is likely for one of the following reasons:
  • the named output file already exists. Merge will not offer to overwrite the file.
  • no file was specified (e.g. C:\files\temp\)
  • the output file name matches a folder name, e.g. C:\files\temp where temp is a sub-folder. This may be a result of choosing an output folder but forgetting the file name - see Output Folder: above.


Actions/Destroy File(s)...

Click or Hover on an item for more ...

Page Contents

  1. Why use secure deletion?
  2. What does Destroy File(s) actually do?
  3. Speed
  4. Early termination
  5. Disclaimer

The Destroy File(s)... action securely deletes selected files by overwriting their file space, preventing file recovery. The dialog allows

  • removal of files marked for deletion, and
  • selection of either a 1-pass or 3-pass overwrite.
Caution: The Destroy File(s) action is not the same as the Delete Permanently routine!

Why use secure deletion?

Today's computer stores much more than just games and documents; many users access secure websites using password protection to

  • buy and sell stocks and securities,
  • manipulate their bank accounts and move money electronically
  • pay bills
  • make purchases using credit card information.

The computer of such a user likely contains records of such transactions which, in the wrong hands, could lead to identity theft, or worse! Although encryption is often used as a security measure, it has already been shown that RSA public key encryption - once considered unbeatable (even using sophisticated computers) in less than thousands of years - may be hacked under certain conditions in as little as several days. In short, we must always think about

  • what is possibly on our computer - passwords, sensitive data, etc., and
  • how can we protect it.

Most of us know that deleted files can be recovered fairly easily by tools such as Recuva, a freeware product. But today computer forensic tools can be used to read residual magnetism on hard drives, possibly re-constructing portions of data that could be used unlawfully. Secure deletion of files - in a way which renders them unrecoverable - is one simple way we can safeguard some of our personal data.

Info: USB flash drives, although not magnetic, may still be recovered in a manner similar to hard drives. Secure deletion can be useful for flash drives as well.

What does Destroy File(s) actually do?

The Destroy File(s) - secure deletion - routine performs the following tasks on each file:

  1. locates file data
  2. determines the actual size of the file on disk, i.e. how many clusters are allocated to that file
  3. opens the file, blocking any sharing mode, thus stopping the file from being opened (by another network user, for example) while it is being overwritten
  4. extends the file out to the end of its last sector, eliminating file slack
  5. starts at the beginning of the file, and writes in the first-pass data, 0x00 over the length of the whole file. This overwriting effectively eliminates the former contents of the file.
  6. if 3-pass overwrite has been chosen, then
    1. starts at the beginning of the file, and writes in the second-pass data - 0xFF - over the length of the whole file.
    2. then, writes in a random set of data, again byte by byte, as the third pass. This random data is obtained via the operating system's cryptography functions, and as such, is extremely difficult to duplicate.
  7. flushes (ie. empties) all memory buffers connected to the file
  8. closes the file and frees the Windows file handle used for the above procedures
  9. deletes the file without sending it to the Recycle Bin.

Speed

Destroy File(s) writes data either once or three times, one byte at a time, and is, therefore, somewhat disk intensive. What this means is that the routine is not as fast as normal file writing. Calculation of an estimated write time would be difficult, since it would be dependent on a number of uncertain aspects, namely

  • the type (number of cores, etc.) and speed of processor
  • the type of drive (IDE, EIDE, SCSI, SATA, USB, flash, etc)
  • fragmentation of the file - fragmented files contain clusters that may be physically farther apart
  • amount of system memory - this affects the speed of system operations which indirectly could affect write times
  • etc.

Attempting to use Destroy File(s) on a large file may create a very long wait time, so the following estimates are included here for reference and comparison:

Hardware: Pentium III processor, 1.2 Ghz, 768 Mb ram
Operating System: Windows XP SP2
Drives: 1: EIDE, 160 Gb
2: USB, 1.0 Tb
Files: 1 2 3
Size: 1 Mb 10 Mb 100 Mb
(1,048,576) (10,485,760) (104,857,600)
1-pass Drive 1: ± 2.1 sec ± 19.6 sec ± 3.2 min
Drive 2: ± 1.8 sec. ± 16.0 sec ± 2.6 min
3-pass Drive 1: ± 9.9 sec ± 1.6 min ± 16.0 min
Drive 2: ± 8.5 sec. ± 1.4 min ± 14.0 min

The times for the USB drive are shorter, I believe, owing to the larger drive capacity (shorter seek time). To put these times into perspective, for the listed hardware, one could estimate the secure deletion times as

  • 2 seconds/megabyte for 1-pass, and
  • 10 seconds/megabyte for 3-pass.

This means that deleting a DVD image file (± 4 Gb), for example, using 3-pass secure deletion, could take as long as 11.5 hours! Sleep on it!

Early termination

On the hardware listed above, the Windows Task Manager reports that Explorer++ is using between 95% and 99% of the CPU time during a Destroy File(s) operation, despite the fact that the process is operating at Normal priority. The effect of this is that

  • the appearance of Explorer++ (not the Destroy File(s) dialog) is that of a program that has "stopped responding to the system", and
  • attempting to switch to another application (via the taskbar) and do something else is a waste of time.

If Destroy File(s) is launched in error on a large file (see times above), it can be prematurely terminated using the Task Manager by

  1. opening the Task Manager using Ctrl+Alt+Delete
  2. selecting the process Explorer++.exe
  3. clicking End Process
  4. agreeing to the warning dialog

The effect of this is to forcefully close Explorer++ and, of course, the Destroy File(s) dialog (a child window), freeing up your system resources. However, take note that

  • settings for Explorer++ (ie. open tabs, views, etc.) may not have been saved, and
  • the file(s) targeted for secure deletion were, in all likelihood, damaged (partially overwritten), but not fully deleted.

Disclaimer

Although the Destroy File(s) action is deemed to be secure, Explorer++ is released under the GNU General Public License and no warranty as to suitability is offered. Section 15 of the GNU license states that the program is provided "as-is" without warranty of any kind.

In other words, if you use the Destroy File(s) routine, and you still get busted for importing ivory when the Police seize your computer and find your files, you're on your own!


Navigation/Go Menu

Click or Hover on an item for more ... (see below for alternate menus)
Windows Vista and 7 may present slightly different menus...

Windows Vista | Windows 7

Screen captures courtesy of David Erceg - thanks!


Go/ Back

Explorer++ maintains a list of previous locations, or history, for each tab. The Back (and Forward) items on the Go menu can walk through this history, much like hyperlinks in HTML browsers (eg. Mozilla Firefox).

Back returns the currently active tab to an older location, closest to the current location in the history. If this item is disabled, the Files pane (active tab) is displaying the oldest location in the history, the location when the tab was first created, or when Explorer++ was first opened.

History

A tab's history can be thought of as a collection (or list) of locations in the order they were visited, with the oldest at one end, and newest at the other. Locations are added to history each time a location is visited by

  • clicking on a drive in the Drives toolbar,

  • clicking on a folder (or other item) in the Folders pane,
  • double-clicking (or single click, with Single click option enabled) on a folder in the Files pane,
  • clicking on a Bookmark, either from the Bookmarks menu or the Bookmarks toolbar,
  • clicking on an item from the Go menu, except Back or Forward,
  • clicking on the Up button on the Main toolbar (same function as on the Go menu), or
  • entering an address in the Address bar which changes the location.

Executing Back or Forward simply walks the Files pane through the current history for a tab; the functions do not add to, or subtract from, the location history. It is possible that history locations may be duplicated, if they were visited by one of the above methods more than once. As Back or Forward is used (either from the Go menu or the Main toolbar), items in history are re-distributed between the Back history and Forward history; Explorer++ maintains histories in both directions.


Go/ Forward

Explorer++ maintains a list of previous locations, or history, for each tab. The Forward (and Back) items on the Go menu can walk through this history, much like hyperlinks in HTML browsers (eg. Mozilla Firefox).

Forward returns the currently active tab to a newer location, closest to the current location in the history. If this item is disabled, the Files pane (active tab) is displaying the newest location in the history.

See here for a more detailed explanation of a tab's history.


Go/ Up One Level

This menu item changes the address of the currently active tab to the parent folder (or location), as shown in the Folders pane (providing it is up to date).

The parent folder (or location) is the folder which contains the folder currently displayed.

If Up One Level is disabled, the Files pane is currently displaying the highest level available in the Folders pane (virtual tree) - Desktop.


Go/User: Data

The top portion of the Go menu allows quick access to special locations, providing access to data which the user may require.

For a definition of virtual folder, see here.

My Computer

This is a virtual folder which displays

  • all volumes on the computer. A volume is a single storage location, usually with a single, drive letter unique to the computer. It can be an entire hard (or floppy) drive, a partition within a drive, a removable (eg. USB) drive, an optical drive (ie. CD, DVD or Blu-Ray Disc™, or a "drive" (with a drive letter) assigned to a folder in the NTFS file system.
  • virtual folders, such as Control Panel
  • renamed real locations such as Bob's Documents (probably C:\Documents and Settings\Bob\My Documents) and Shared Documents (probably C:\Documents and Settings\All Users\Documents); drive letters may vary with different installations of Windows.

Note that My Computer may contain different items, or may display differently in each version of Windows.

My Documents

This is a real folder (probably C:\Documents and Settings\<username>\My Documents - drive letters may vary) which Windows creates as part of its installation. The purpose for this folder, at least as intended by Windows, is to act as a parent folder for all the user's documents and data. This may not suit each user's purposes, but many programs default to this location for data storage.

My Music

This is a real folder (probably C:\Documents and Settings\<username>\My Documents\My Music - drive letters may vary) which Windows creates as a subfolder of My Documents, intended to house digital music files (eg. MP3, WAV, etc.).

My Pictures

This is a real folder (probably C:\Documents and Settings\<username>\My Documents\My Pictures - drive letters may vary) which Windows creates as a subfolder of My Documents, intended to house digital image files (eg. JPG, GIF, PNG, etc.).

Desktop

Desktop is a virtual folder, considered by Windows to be the parent (ie. the topmost item in the hierarchy) of all items in the virtual tree shown in the Folders pane. The practical use for Desktop is that it always contains all items shown on the user's actual desktop (ie. the Windows screen when no application windows are visible).

Although Desktop is considered to be a virtual folder (for purposes of the computer's virtual tree), it is really comprised of 2 real folders

  • C:\Documents and Settings\<username>\Desktop, and
  • C:\Documents and Settings\All Users\Desktop

The (root) drive letter may vary with different installations of Windows.


Go/User: Special

The bottom portion of the Go menu allows quick access to special locations, for computer configuration, etc.

For a definition of virtual folder, see here.

Recycle Bin

This is a virtual folder that displays deleted files and folders from various locations. This is the same Recycle Bin usually shown on your Desktop. Selected items may be restored by using the "Restore" menu item on the context (ie. right-click) menu. Note that files deleted from a Local USB (ie. external) drive will not be visible in Recycle Bin unless the drive is physically and logically connected to your system. Files deleted from a Removable USB drive (eg. flash or jump drive) do not appear in the Recycle Bin.

Control Panel

This is a virtual folder which displays various tools (ie. applets, or small applications) used to configure your system or other applications. Most applets are physically housed in the WINDOWS\system32 folder, but some may be elsewhere. This is the same Control Panel usually shown on your Start Menu.

Printers and Faxes

This is a virtual folder which displays links to all printers and faxes connected to your system. This location may also show drivers which control various devices. The context (ie. right-click) menu for each device or driver may show various control items including Properties, which usually allows some setup procedures.

CD Burning

Windows XP and higher (Vista, 7) has built-in routines for native burning (ie. writing) of CDs. This burning requires a buffer where data is kept that will be written to the CD; this buffer location is a folder reserved especially for this purpose - "CD Burning". Files and folders contained in this folder are slated for writing to CD, but could be removed (ie. deleted) if necessary prior to the actual write.

My Network Places

This is a virtual folder which displays frequently visited network locations which have been added; these locations are essentially "network bookmarks". These network places may be added using the Add Network Place wizard, displayed in the Files pane. Two other network tasks (wizards) are also available from the Files pane - the Network Setup Wizard, and the Wireless Network Setup Wizard. Explorer++ displays these three wizards in the Files pane along with previously set up network places, while Windows Explorer shows them (under expanded titles) as tasks, when the Folders pane is turned off.

Incomplete: My Network Places currently does not provide access to the actual network, except through the Folders (treeview) pane. Network places are housed under the Entire Network\Microsoft Windows Network item.

Network Connections

This is a virtual folder which displays networks which your computer is connected to, or can connect to.

Incomplete: Network Connections currently does not provide information about the Type, Status or Owner (available columns for display). This information (and more) can be viewed by selecting Control Panel in the Folders pane, right clicking Network Connections in the Files pane (for the context menu), and selecting Explore - this opens Windows Explorer which will display this information.


Navigation/Bookmarks Menu

Click or Hover on an item for more ...

User bookmarks are displayed at the bottom of the menu. Clicking on a user bookmark "goes there", ie. set the active tab in the Files pane to the location for that bookmark. If the location does not exist (ie. folder for bookmark has been renamed or deleted), no change is made.


Bookmarks/ Bookmark This Tab...

Click or Hover on an item for more ... (Details shown expanded)

Name:

The Name field allows entry of the final bookmark name, as it will be displayed on the Bookmarks menu. You should choose a name that conveys (to you) the usage of this location.

Create In:

Bookmarks may be built in a hierarchy, similar to the tree shown in the Folders pane, through use of the New Folder... button. Bookmarks, therefore, may be created on any level (ie. in any subfolder) which exists. Clicking this field (or the drop-down button) opens a list which shows all current levels; the user may select which folder or level to create the new bookmark in, as in the image.

New Folder...

This dialog creates a subfolder in Bookmarks (the root level for user bookmarks), or within any other bookmark subfolder which currently exists. Note that folders may contain bookmarks, but do not have a bookmark associated with them.

Click or Hover on an item for more ...

Bug: Creation of a new folder (ie. one level below Bookmarks) is fine, but creation of second folder within the first (ie. two levels down) causes the folder names to be displayed incorrectly on the Bookmarks menu. All subfolders past the first level are shown with the same name - the name of the lowest level. Workaround: The Organize Bookmarks dialog displays the bookmark hierarchy and folder names correctly.

During creation of a new folder on the same level, Explorer++ does not check for duplicate names.

See also - fatal error (bug), when deleting empty bookmark folders.

Location:

Normally, this field shows the URL (ie. location) of the currently active folder in the Files pane, but you may edit it as desired. Make sure that the location you edit actually exists.

Info: Any bookmark with no location (ie. empty string) will open in the default new tab folder.

Description:

This field is normally not shown, but appears as part of the bookmark's Properties dialog in the Organize Bookmarks tool. Any user comments about this bookmark may be entered here, such as, perhaps:

  • the use of this folder (eg. "Temporary storage for untested software", "Killer apps!")
  • a date ("Wednesday's accounting updates")
  • backup information ("These ZIP files have been archived")
  • etc.

Show on Bookmarks Toolbar

Checking this box (or menu item) forces the bookmark created to be shown on the Bookmarks toolbar. If this box is not checked at the time of bookmark creation, it may be checked later as part of the Properties dialog in the Organize Bookmarks tool. Folders housing bookmarks may also be designated to show on the Bookmarks toolbar.


Bookmarks/ Organize Bookmarks...

Click or Hover on an item for more ...

Folders tree

This pane shows the hierarchical tree structure of the bookmarks collection. Folders can be expanded to show their contents (more folders only). Selecting a particular folder displays the contents (including bookmarks) in the Bookmarks & Folders pane to the right. The folder Bookmarks is the parent (or root) folder of all subfolders or bookmarks.

Bookmarks & Folders

This pane displays the contents of a selected folder in the Folders tree to the left. In addition to the bookmark or folder's name, it's location and any comment (Description) are displayed. The three columns may be resized (by dragging the edges of the column headers), but not dragged into a different order.

Double-clicking on a bookmark ( [image]) transfers the current tab to that location, ie. goes to the bookmark, while double-clicking on a folder ( [image]) opens that folder and displays its contents.

Context Menu

Click or Hover on an item for more ...
Each bookmark item in this pane has a context (ie. right-click) menu which is quite similar to the context menu for items on the Bookmarks toolbar, with the addition of a Show on Bookmarks Toolbar item.
Incomplete: The New Bookmark... and New Folder... items on this menu are not yet coded, ie. they are non-functional.

Move Up, Move Down

These buttons move a selected bookmark (or folder) in the Bookmarks & Folders pane up or down in the bookmarks list. Only a single bookmark or folder may be selected at a time.

Delete

This button deletes (with a confirmation dialog) a single bookmark or folder selected in the Bookmarks & Folders pane. Deleting a folder obviously deletes all the bookmarks and folders it contains.

Bug: Deleting a folder does not update the Folders tree until the next opening of the Organize Bookmarks dialog.

It is possible to create a new folder, then save the bookmark elsewhere or cancel saving the bookmark, thereby creating an empty folder. Attempting to subsequently delete an empty folder will cause a fatal crash.
Workaround: Prior to deleting a folder, select it in the Folders tree to ensure that it is not empty. If necessary, add a dummy bookmark to the folder prior to deleting it.

Properties

You edit the properties for any item selected in the Bookmarks & Folders pane. If the item is a folder, then the Location: field is absent.

Click or Hover on an item for more ...


Navigation/Tools Menu

Click or Hover on an item for more ...


Tools/ Search...

Click or Hover on an item for more ...

The Search dialog provides a quick and convenient way to locate files or folders, based on a search pattern (partial name, etc.). The results area provides standard Shell context menus for each item found, allowing you to view, edit, copy, delete, etc. the files or folders.

Info: The Search routine can only find files/folders by name or attributes; no searching for text within a file can be done.

Filename

This field contains either

  • the partial file name (or search pattern) to search for. Although wildcard patterns may be used, it is not strictly necessary to do so; the search implemented here will match a partial filename (similar to the built-in Windows search tool) without using wildcard characters. A drop-down list is available with quick access to previous search patterns. If using a partial file name (or wildcard) pattern here, make sure the Use Regular Expressions checkbox is not checked to prevent the pattern from being interpreted as a regular expression.

or

  • a regular expression to match. Using a regular expression requires the Use Regular Expressions checkbox be checked.
Tip: The Filename: field is also used for entering Regular Expressions, which can be quite long. Currently, this field does not scroll, so your long expression may not be possible to enter. Simply resize the whole window (larger) for more room in the edit box.

Directory

This field should contain the folder in which to perform the search, or the parent folder, if the Search Subfolders box is checked. The button beside the field opens a Windows Browse For Folder dialog (see tip for a picture of this Windows dialog), allowing the user to navigate to and set the Search Directory. A drop-down list is available with quick access to previous search directories.

The Search Directory defaults to the folder/directory of the currently active tab.

Attributes

Checking any attributes provides a filtering mechanism; files searched must satisfy the Filename pattern AND the attributes if they are to be included in the results.

Case Insensitive

The state of this checkbox determines whether text case (i.e. UPPER or lower case) will be considered during the search.

  • checked - searches are case insensitive, that is, UPPER and lower case are considered the same. Searching for "gif", for example, will also find "GIF" and "Gif".
  • not checked - searches are case sensitive and the target and results case must match exactly, that is, "gif" ≠ "GIF" ≠ "Gif".

Search Subfolders

Normally, the search would be done only in the scope of the folder shown as the Directory. However, if this box is checked, all subfolders (and subfolders of subfolders, etc.) will be included in the search. Results can be from either the search Directory, or any subfolder.

Use Regular Expressions

If this box is checked, then the text entered in the Filename edit box is assumed to be a regular expression and the search is done using pattern matching instead of simple file name comparisons. Regular expressions, while appearing complicated to the user of text and wildcard expressions (e.g. "*.jpg"), can be a more flexible and powerful approach to searching for files and folders. Having this tool available - as well as conventional (i.e. non regular expression) text searching - provides superior capabilities and choice to the user. For an introduction (and reference) to the use of regular expressions in Search, see the Regular Expression Primer. Regular Expression searches obey the settings of the Attributes and Search type checkboxes.

Results pane

When the search is completed, this list shows the name and path (ie. location) of all files found which matched the criteria for (partial) name and attributes. The Name and Path columns are resizable, and sortable (ascending or descending, by clicking on the column header) for convenience when numerous results are visible.

Tip: Each file in the Results pane has a context (ie. right-click) menu. Two items on this menu are of particular interest:

  • Open - this opens the file in any application registered to that file type or presents a dialog if the type is not registered. This may also be accomplished by double-clicking on the file.
  • Open file location - this opens a new tab at the folder which houses the file. The target file is already selected in the new tab. If multiple files were selected originally, only a single tab is opened and a single file selected.

This context menu is constructed from Windows shell associations; items present will vary with the file type.

Info: The Microsoft .NET framework, when present on a system, creates a subfolder in the Windows folder called "assembly". The nature of the .NET installation may interfere with Explorer++ (Windows Explorer's exploration is modified) successfully browsing this folder. If this folder is included in your search (usually by virtue of using the Search Subfolders option), some results unusual results (eg. incorrect file names, locations) may be expected, but these erroneous results are usually obvious.

Status:

This area shows

  • the folder being searched (quickly!), as the search progresses,
  • "Cancelled." - if the user stopped the search prematurely (by clicking the Stop button or by pressing Enter or spacebar), or
  • the final count of folders and files found, when the search completes.


Tools/ Search.../Regular Expression Primer

Explorer++'s Search tool can search for files and folders using regular expressions, but this concept might be foreign to some users. This primer hopes to shed enough light on the subject to allow you to use regular expressions - at least in a simple form - in the Search too. For more in-depth treatment of this subject, see other resources; the Internet has volumes of information available. Note that because only file and folder names are being searched for, regular expressions which involve multiple lines and replacing text are not used.

Caution: Be mindful of what you read on the Internet; regular Expressions are somewhat platform/application specific. While common behaviours exist, some platforms/applications introduce syntax which may not work in Explorer++. For the most part, the Search dialog uses a subset of TR1 Regular Expressions.

What are Regular Expressions?

Regular expressions are a concise and flexible notation for finding and replacing patterns of text - the replacing part won't be covered here, as the nature of Search relies on finding instead. Regular expressions are written in text (letters, numbers and special symbols) using 2 distinct categories:

  • literals - these are characters (or groups of characters) which are to be found in the target string as-is. Any characters which are not used as meta-characters can be considered as literals; and
  • meta-characters - special characters which do not represent themselves, but are a coded representation of text sequences to find.

Meta-characters generally consist of the following characters: ˆ $ . * \ [ ] { } ( ) + ? |

Some other characters might also be considered meta-characters when used in a special context. Meta-characters may also be used as literals (with a special syntax) if needed. Unfortunately, implementations of regular expression handlers do vary in the language (based on the application and operating system), but the basic set of instructions should be the same. For the purposes of Search, we will only consider basic searching.

Do I need to know Regular Expressions?

The short answer is probably not - since with Explorer++ we are only searching for file and folder names, likely the conventional method of searching (limited wildcards, text) may be sufficient. But regular expressions can accommodate that weird search that you might need to do and can also be used to combine what might otherwise have been multiple searches into a single search. Many other applications provide regular expression capability, particularly for searching text within files and search-and-replace situations. Once you learn regular expressions, you may never go back to conventional searching.

How do Regular Expressions work?

The regular expression is a set of mini-rules, describing what is to be found in the target string. The mini-rules are applied to the string in sequence - left to right - and if the described text is found, a pattern match is accomplished (success). Once a match is made to an element (mini-rule), the text - in the target string - that caused the match is considered thrown away, and is not used again.. If any of the rules fail - that is, the anticipated pattern of text is not found - then the whole regular expression is considered to have failed (no pattern match). In Explorer++'s Search tool, if a pattern match is made (subject to a match also with file attributes and case as set in the dialog), the file is listed in the results pane. Also, in this context (matching file/folder names), the regular expression must describe the entire file/folder name, minus the path, of course. This is not as difficult as it sounds since regular expressions have wildcards, repeats, etc. to accommodate unknown characters. Some other aspects of regular expressions - handling multiple lines, replacing text, etc. are not applicable and are not covered here.

Elements (or Mini-rules) - short list

The following table contains a few meta-characters and elements to demonstrate the power of Regular Expressions. Refer to the Regular Expression Reference (Appendix C) for more elements and details.

EXPRESSION | SYNTAX | ORDINARY NAME | DESCRIPTION | EXAMPLES
Any character | . | dot or period | This is the wildcard character - matches any single character (except a newline - not used in file/folder names) | s.s matches sys (system) and ses (session), but not sores
Zero or more | * | asterisk | matches zero or more occurrences of the preceding expression, and makes all possible matches | a*b matches b (bat) and ab (about) .* matches any sequence of characters
One or more | + | plus | matches at least one occurrence of the preceding expression, same as {1,} (see Repetition below) | rol+ matches rol and rolllll, but not ro
Or | | | pipe, vertical line | matches either the expression before or the one after the OR symbol (|). Mostly used in a group. | AL|TE matches ALE or ATE
Group | () | parentheses | isolates an Or expression | a(jpg|jpeg) matches ajpg or ajpeg
Escape | \ | backslash | when it precedes a meta-character, the combination is taken as a literal. Some meta-characters, namely ˆ$.[]{}()+, may be used in file/folder names. | a\.txt matches a.txt

Demonstrations

  • Navigate to the C:\Windows folder. Your drive letter may be different, depending on your installation.
  • Open the Search dialog (Ctrl+F)
  • Clear all attribute checkboxes and the Search Subfolders checkbox. Check the Case Insensitive checkbox. Check the Use Regular Expressions checkbox.
  1. Use .*\.(ini|log) as the Filename:, and do a search. What did it do? It should have returned all ini and log files; here's a breakdown of what happened...
.+ This is the wildcard (any character) followed by "one of more repeats". This matches any character (and at least one!) until...
\. This is the meta-character "." but escaped; this considered the "." as just a dot/period (literal). This matches the dot between the file name and the file extension.
(ini|log) This is a group (parentheses), just to avoid any possible misinterpretations. Inside the group is "ini" or "log"; in other words, match "ini" or "log" as the extension (or at least, the next characters). If any files have characters after "ini" or "log", they won't match the expression.
  2. Use .*\d+.*\.\D+ as the Filename:, and do a search. This one is a little more complex - refer to Appendix C for a bit more detail on each element. Here's a breakdown first...
.* This is the wildcard followed by "zero or more repeats". This skips/matches y everything (if it exists) until the next element.
\d+ | \d is a character class (shorthand notation for digits), repeated one or more times. This matches 0-9 but nothing else (at least one digit).
.* Again, this skips/matches y everything (if it exists) until the next element.
\. The dot/period character (escaped) is match, just before the extension.
\D+ | \D is a character class (shorthand for not a digit) - repeated at least once. This matches the extension, but only if there are no digits.

So what did it find?

  • all files with at least one digit in the filename, but no digits in the extension. And it must have an extension. Try doing that with a conventional wildcard search!
  3. Here's one more demonstration, for keeners! This time
    • Navigate to your Windows folder (usually C:\Windows).
    • Again, no attribute filtering and check Case Insensitive. Check the Search Subfolders checkbox - we want to scan all of Windows subfolders (it is relatively quick!).
    • Use   \{[[:xdigit:]]{8}-([[:xdigit:]]{4}-){3}[[:xdigit:]]{12}\}
      as the Filename:, and do a search. Don't type it, just copy from here (select it, Ctrl+C - careful that you don't pick up any leading spaces) and paste (Ctrl+V). You will have to break it down yourself, if you want, but what did it find?
      • all folders in the Windows folder (or subfolder thereof) named with a GUID (Globally Unique IDentifier - see Wikipedia here).


Tools/ Customize Colors...

This tool allows Explorer++ to display files in different colors, according to rules which modify the display of files by filename and/or attributes. Like the Filter routine, coloring certain files or folders aids in quickly finding what you want.

Click or Hover on an item for more ...

Rules list

This list shows all color rules, by their description (ie. name). Their application to files in the Files pane is by their order of appearance in this list; the first rule (top) is applied first, the bottom of the list is applied last. Individual rules (ie. one at a time) may be selected for re-ordering, editing or deletion.

New...

This opens the New Color Rule dialog for creation of a new rule. The dialog is virtually identical in form and function to the Edit Color Rule dialog, buts adds to the rule list rather than editing an existing rule.

Edit...

This function edits the currently selected rule.

Click or Hover on an item for more ...

Description:

Enter a description in this field; this is the name that will identify the rule in the Rules list.

Color:

The color assigned to files which match this rule is shown in a small swatch.

Change color...

This button opens a standard Windows Color dialog which allows you to set a new color. You may

  • choose a color from some common colors, or
  • define one using
    • RGB (Red/Green/Blue) notation
    • Hue, Saturation and Luminescence values, or
    • visual selection

Filename pattern:

Rules may specify a filename pattern in addition to, or instead of, attributes. If a file name matches this pattern, then that portion of the rule is satisfied. Filename patterns are entered using wildcard patterns, in a manner similar to the old DOS wildcards. For example, the filename pattern
        *_*.*
would match any file containing an underscore character. The most common usage would likely be to match certain files by file extension, as in a pattern of
        *.gif
which would match any GIF image files.

If attributes are also checked, then both the filename pattern AND the attributes must match in order for the rule to succeed and the file be colored.

Bug: In the current version of Explorer++, entering a Filename pattern, or editing an existing pattern, is broken. Filename patterns always revert to a null string.

Workaround: enter the filename pattern manually using Regedit.exe (advanced!) after the rule is created. You must close Explorer++, edit the registry, then reopen Explorer++. The registry key for the rule will be located under HKEY_CURRENT_USER\Software\Explorer++\ColorRules. XML files - if using Explorer++ in portable mode - may be edited using a text or XML editor.

Attributes

File attributes may be specified in addition to, or instead of, a Filename pattern. Attributes may be the common attributes (as can be changed from the File menu), or may also be NTFS specific, namely

  • Compressed - file is compressed using native Windows compression, or

  • Encrypted - file is encrypted using native Windows encryption.

Note that checking any attribute box in this dialog does not affect the attributes for any file, it merely reads the attributes as part of this rule.

Bug: In the current version of Explorer++, unchecking any existing attribute as part of a rule, does not work; the attribute remains applied to the rule.

Workaround: create a new rule with the correct attributes applied, then delete the original rule. If desired, advanced users may also edit the attributes in the registry or XML file, in a manner similar to the method described in Filename pattern (Bug). Attributes are additive, with the following values:

Attribute | Hex Value | Decimal Value
Compressed | 0x800 | 2048
Encrypted | 0x4000 | 16384
Archive | 0x20 | 32
Hidden | 0x2 | 2
Indexed | 0x2000 | 8192
Read-only | 0x1 | 1
System | 0x4 | 4

Move Up/Down

The Move Up and Move Down buttons move a selected rule up or down in the list. Priority of application of rules to the Files pane is determined by their order in the list.

Delete

Clicking the Delete button deletes a rule (currently selected) from the list; a confirmation dialog is issued prior to deletion. There is no way to recover a deleted rule.


Tools/ Options... (General)

Click or Hover on an item for more ...


Tools/ Options... (Files and Folders)

Click or Hover on an item for more ...


Tools/ Options... (Window)

Click or Hover on an item for more ...


Tools/ Options... (Tabs)

Click or Hover on an item for more ...


Tools/ Options... (Default Settings)

Click or Hover on an item for more ...


Navigation/Help Menu

Click or Hover on an item for more ...


Help/ Help

This menu item opens the help file (this file) at its default page.

You might see the following dialog instead:

which means that you haven't yet installed the help file. Click on the link in the dialog to open your browser at the Explorer++ download page, and download the file (Explorer++ Help.chm) using the Help File link. It may be in an archived (i.e. zip file) format; if that is the case, extract it first, then follow the next steps:

  • the help file must be named Explorer++ Help.chm (its default name), and
  • the help file must be located in the installation directory, i.e. the directory housing the executable (Explorer++.exe). Move it to that location.
  • You may need to "Unblock" (i.e.. right-click file → Properties → Unblock) the help file after extracting. The file may be blocked from usage by Windows' security routines. It is a safe file.

As of the current version of Explorer++, (context sensitive) help using the F1 hotkey is not implemented. Only the Help menu item is functional.


Help/About Explorer++...

Click or Hover on an item for more ...


Toolbars/Overview

Explorer++ has 5 internal toolbars, any of which may be enabled (made visible) by checking one of the menu items. They are

Toolbar | ID* | Customizable | Comments
Address Bar | 1 | no | set or displays the address of the currently active tab (folder)
Main | 0 | yes | provides 19 (in the current version) common tools or actions which may be quickly accessed by clicking a button's icon
Bookmarks | 2 | limited | displays selected bookmarks as buttons/icons along with their name
Drives | 3 | no | shows and accesses all available volumes (ie. drives)
Application | 4 | yes | houses shortcuts to selected applications

* IDs are maintained internal to Explorer++, but may be useful when editing the Windows registry, or the "config.xml" (ie. portable settings) file.

Moving toolbars

When unlocked, he toolbars may be relocated (ie. docked) and resized, and placed on separate rows or combined on a row to save space.

Using a toolbar's grip (found at the left side of the toolbar), it may be dragged-and-dropped to a new row, or moved along that row effectively resizing the toolbar to its left. Moving a toolbar along a row is only possible when there is more than one toolbar per row.

Dragging a toolbar up will place it on a row with another toolbar, while dragging a toolbar down (to the bottom-most row) places it on its own row.

Toolbar positions are preserved by Explorer++ for the next session.

Bug: If the Address Bar has a second toolbar on the same line to the right of it, it may be partially obscured, even after restarting Explorer++.

Chevrons

If there is insufficient room to display all toolbar items, a chevron symbol (») is used; clicking on the chevron opens the rest of the toolbar, as a menu.


Toolbars/Address Bar

Click or Hover on an item for more ...

For general information about Explorer++'s toolbars, ie. moving, resizing, customizing, etc., see the toolbars Overview.

The Address Bar serves 3 general purposes:

  1. it displays the icon associated with the current folder (tab),
  2. it displays the address of the current folder (tab); this address can be copied to the clipboard (if desired), and
  3. it allows the user to enter an address and, using the Go button, jump to that address.

Folder icon

This area displays any folder icon associated with a particular folder; the default is usually as shown in the image. Most special folders on the Go menu have distinct icons associated with them and will display those icons here.

Tip: Dragging and dropping the Address Bar's icon to a folder (in the Folders or Files pane) - or to another tab - creates a Windows shortcut (ie. a LNK file) in that folder. The shortcut points to the original location.

Address/text field

Address display

If a location for the active tab is selected, by any valid means, the address/text field of the Address Bar displays the current address. If the address is too long to fit in the space allotted (ie. the Explorer++ window has been resized, and the Address Bar is now too small to display the full address, or the address is deeply nested in subfolders), the text in the address/text field can be scrolled by placing the cursor in the field, then moving the curser (left/right arrow, Ctrl+left/right arrow, etc.).

Text in the address/text field may be selected and manipulated (eg. copied to the clipboard), by using Windows hotkeys (eg. Ctrl+C for copy), or through the use of a small context (ie. right-click) menu. The Copy Folder Path operation copies the entire address to the clipboard.

Address entry

You may enter an address in the address/text field and jump to that address by pressing Enter or clicking the Go button. The address must one of either

  • a fully qualified path, ie. <drive letter>:\<folder>\<folder>\... etc. An example might be:
        C:\WINDOWS\system32\drivers
    Note that fully qualified paths should not end in the backslash ( \ ) character.
    Tip: Every time you enter backslash ( \ ) character, Explorer++ opens a special (resizable) window and displays a list of the contents (files and folders both) of the path as typed so far (if valid). You may select a folder from this list; Explorer++ will jump to that folder. Selecting a file will attempt to open it in any registered application, the same as if you tried to open the file using a double-click (or single-click, with an option set). A refresh will restore the true address.

  • the name of a subfolder in the current location. The folder must already exist. This is the only time Explorer++ will accept less than a fully qualified path, except for special locations (following).

  • the name of a special location. Explorer++ recognizes the following locations in the Address Bar as special:
    Special location | Target
    Desktop | <drive>:\Documents and Settings\<user>\Desktop
    Documents | <drive>:\Documents and Settings\<user>\My Documents
    Pictures | <drive>:\Documents and Settings\<user>\My Documents\My Pictures
    Music | <drive>:\Documents and Settings\<user>\My Documents\My Music
    Videos | <drive>:\Documents and Settings\<user>\My Documents\My Videos

    Entering one of the above locations (case-insensitive) in the address/text field and clicking the Go button (or pressing Enter) jumps to the target location. Explorer++ also recognizes several virtual folders, as shown on the Go menu, namely

    • My Computer
    • Recycle Bin
    • Control Panel
    • Printers and Faxes (opens in Windows Explorer)
    • My Network Places

    although, it is likely easier just to use the Go menu for these locations.

Address drop-down

The drop-down list for the Address Bar shows all subfolders (folders only - no files) in the current location. You may click on any folder in the list to put its name in the address/text field; pressing Enter or clicking the Go button will take you there.

Go button

The Go button, when clicked, set the address for the current tab to the address shown in the address/text field of the Address Bar. Pressing Enter is the same as clicking the Go button when the Address Bar has the focus. The Go button has a context (ie. right-click) menu identical to the Toolbars menu.

Info: The Tab, Shift+Tab, F6 and Shift+F6 keys cycle the focus in Explorer++ between the Address Bar, Folders pane and the Files pane.


Toolbars/Main Toolbar

For general information about Explorer++'s toolbars, ie. moving, resizing, customizing, etc., see the toolbars Overview.

The Main toolbar provides access to some commonly used Explorer++ functions. The following buttons are available on the Main toolbar, using the Customize dialog; your toolbar may not contain all buttons. The table below shows the buttons loosely organized by function; your toolbar may have buttons in any order.

Button | Tooltip | Brief Description
 | Back | returns the tab to the previous location in the tab's history, if one exists
 |  | this (separate) button - part of the Back button - opens a menu showing a list of history locations, in the Back direction. Clicking on an item returns the tab to that location directly.
 | Forward | returns the tab to the newest, but previously visited location in the tab's history, if one exists. This location only exists if the Back function has been used; ie. the Forward history is only created by the Back function.
 |  | this (separate) button - part of the Forward button - opens a menu showing a list of history locations, in the Forward direction. Clicking on an item returns the tab to that location directly.
 | Up | goes to the parent folder of the current location
 | Folders (enabled) | clicking this button toggles the Folders pane off (hidden)
 | Folders (disabled) | clicking this button toggles the Folders pane on (visible)
 | Copy | places selected items (files and folders) on the clipboard
 | Cut | removes selected files and folders and places them on the clipboard. Removal is done at the time of pasting.
 | Paste | pastes data or files/folders from the clipboard
 | Delete | deletes files/folders to the Recycle bin (except for removable drives)
 | Delete permanently | deletes files/folders without sending them to the Recycle bin
 | Properties | displays properties of a file or folder. Multiple files/folders (mixed) may also be used.
 | Search | finds files/folders by name and/or attributes
 | New Folder | creates a new folder in the current folder (tab)
 | Copy To | copies selected files and folders to a different location
 | Move To | moves selected files and folders to a different location
 | Views | cycles through available views for the current tab
 |  | this (separate) button - part of the Views button - opens a menu showing available views and allows the user to select a view directly (menu item is checked)
 | Show Command Prompt | opens a command prompt (ie. DOS box) in the current directory
 | Refresh | re-sorts and re-displays the current Files pane, subject to current settings (ie. Sort By, etc.)
 | Bookmark the current tab | creates a new bookmark
 | Organize Bookmarks | opens the Organize Bookmarks dialog
 | Create a new tab | creates a new tab in the files pane


Toolbars/Bookmarks Toolbar

For general information about Explorer++'s toolbars, ie. moving, resizing, customizing, etc., see the toolbars Overview.

The Bookmarks toolbar displays bookmarks (previously created) which have been optionally designated to show on the toolbar by checking the Show on Bookmarks Toolbar box. Clicking on the button for a bookmark opens that bookmark (ie. location) in the current tab. Hovering over a bookmark button displays the name and location of that bookmark as a tooltip.

Bookmark folders may also be shown on the Bookmarks toolbar; clicking on the button for a folder opens that folder's bookmarks in a menu.

Context Menu (button)

Each button on the Bookmarks toolbar presents the following context (ie. right-click) menu:

Click or Hover on an item for more ...

New Bookmark...

This function is similar to the Bookmark This Tab... item on the Bookmarks menu, but does not operate on the current tab's location. Therefore, the dialog opens with

  • no bookmark name - the user must supply this, and
  • no location - the location may be entered manually (if known) or copied/pasted from somewhere else (perhaps from the Address Bar on another tab). Any bookmark created with no location will open in the default new tab folder.
Bug: Bookmarks created by this routine do not show on the Bookmarks menu until Explorer++ is re-started.
Tip: Using the middle-mouse button on a bookmark shown on the Bookmarks toolbar opens that bookmark in a new tab.


Toolbars/Drives Toolbar

For general information about Explorer++'s toolbars, ie. moving, resizing, customizing, etc., see the toolbars Overview.

The Drives toolbar displays all available volumes currently available on your computer. Clicking a button on the toolbar changes the address of the current tab in the Files pane to the root of that drive letter (eg. clicking C: opens C:\ in the current tab). Hovering over a drive button displays the free space and total size of the drive as a tooltip, if available (not available if the drive is not ready).

Some users may find it helpful to resize the Drives toolbar to its smallest, and dock it on the same row as the Main toolbar (right-hand edge). This frees up space, while still providing the functionality of quickly accessing every drive. When the toolbar is docked in this way, only the chevrons are visible; clicking on the chevrons opens the toolbar as a menu.

Tip: Using the middle-mouse button on a toolbar drive opens that drive in a new tab, however, docking the Drives toolbar in this way does not allow this usage on a menu item (see tip here).

Context Menu (button)

Each button on the Drives toolbar has a context (ie. right-click) menu, with the same functions that would be available from Windows Explorer, or from My Computer (opened in Windows Explorer). In addition, you may open the drive in a new tab from this menu. The functions available on the context menu may vary depending on

  • the type of drive (ie. Removable, Local, CD, etc.), and
  • other applications you may have installed which affect the context menu.


Toolbars/Application Toolbar

For general information about Explorer++'s toolbars, ie. moving, resizing, customizing, etc., see the toolbars Overview.

The Application toolbar shows a collection of your favorite applications; each button shows the application name and icon, if any. Buttons on the Application toolbar are similar to shortcuts to the applications themselves, providing instant access to your favorite tools. Unlike true Windows shortcuts, application toolbar buttons may have no parameters.

Context Menu (button)

Click or Hover on an item for more ...

Open

Clicking this menu item opens the application (corresponding to the button, of course). This function is the same as clicking the button.

Tip: Files from the Files pane may be dragged-and-dropped onto an application button to open them in that application. Selecting multiple files and using drag-and-drop will open all selected files, providing the application supports this behavior. Example: multiple text files may be dragged-and-dropped onto the application button for a multi-tab text editor to open all files.

New Application Button...

Click or Hover on an item for more ...

Name:

The text entered here is the name for the application that could be shown on the toolbar along with the icon (application specific or Windows default).

Command:

This field is the URL to the executable for the application. You may enter the URL manually, if it is known, or browse for the executable using the Open dialog. If the target file is not an executable (eg. a text or .txt file), clicking the application's button on the Application toolbar will open the file in any registered application. For example, selecting this CHM file (eg. C:\Program Files\Explorer++\Explorer++ Help.chm) will open the file using the Windows hh.exe (Html Help executable) application.

Open (find executable)

This button opens a standard Windows dialog (Open) which allows the user to browse for the application executable file. Note that the default file type is EXE, but selecting All Files will browse for other types of files (.com, .txt, etc.). The Open as read-only checkbox serves no purpose.

Show name on application toolbar

This box (checked by default) enables/disables the display of the Name: field for the target application. Clear this box if the icon is self-explanatory, ie. the nature of the application is clear.

Info: This item (New Application Button...)also appears on the Application toolbar context menu (ie. right-click over blank space on toolbar).

Delete

This menu item deletes the application button from the toolbar, with a confirmation dialog. It cannot be recovered.

Properties

This function opens the properties for the application shortcut and button. A dialog (Edit Application Button) is opened which is identical in function to the New Application Button, with all pertinent fields (for the button) already filled in. Fields may be edited from this dialog.

Tip: Re-ordering buttons on the toolbar (advanced - be careful!)
Application buttons are normally placed on the Application toolbar in the order they are created. Through judicious use of the Regedit application, they may be re-ordered.
  1. open Regedit and navigate to HKEY_CURRENT_USER\Software\Explorer++\ApplicationToolbar
  2. select the ApplicationToolbar key in the left panel, and Export its contents to a suitable location using the context menu
  3. edit the file to renumber the sub-keys (application buttons). They must always be numbered 0, 1, 2, etc. The first button is 0, the second is 1, and so on. The actual order they appear in (inside the file) is not important.
  4. make sure Explorer++ is closed
  5. Double-click on the edited file to re-enter the data into the registry.
  6. That's it!

A similar technique applies to using Explorer++ as a portable application - edit the config.xml file to re-order the application button lines. A number is not used; the order of the lines (under <ApplicationToolbar>) determines the button order.


Toolbars/Lock Toolbars

This menu item - whether on the Main menu (View/Toolbars), or on the context menu of one of the toolbars themselves - toggles the locked state of all toolbars.

  • Locked - toolbars are not movable, and have no grips (see Moving toolbars for image of grip)
  • Unlocked - all toolbars have grips, and are movable.

Although it does not affect functionality, it is recommended that toolbars are locked, once positioned, to avoid any accidental movement, etc.

Tip: The Main toolbar may be customized, even in the locked state.


Toolbars/Customize...

Click or Hover on an item for more ...

The Customize Toolbar dialog manages buttons on the Main toolbar by

  • adding a button
  • removing a button or separator bar
  • re-ordering buttons.

Available toolbar buttons

This pane shows the toolbar buttons that are available, ie. have not been included in the current toolbar configuration. The Separator item is always available. For more information on available buttons, see the Main toolbar.

Add -›

Clicking this button adds the currently selected tool (in the Available pane) to the toolbar. The button is inserted above the selected item in the Current pane.

‹- Remove

Clicking this button removes the currently selected button (in the Current pane). The button removed becomes available in the Available pane, but is no longer shown on the toolbar.

Current toolbar buttons

This pane shows the buttons (and Separators) currently assigned to the Main toolbar. The button at the top will show as the left-most button on the toolbar.

Close

This button closes the dialog, preserving the current layout of the Main toolbar.

Reset

This button resets the Main toolbar to its default button set.

Move Up

This button moves the selected item (in the Current pane) up in the list. This has the effect of moving that item one position to the left on the Main toolbar.

Move Down

This button moves the selected item (in the Current pane) down in the list. This has the effect of moving that item one position to the right on the Main toolbar.


Navigation/Tab bar

The Tab bar displays tabs which are currently available for use; each tab is essentially a separate Files pane, viewing a specific location.

The user may quickly switch from location to location simply by selecting the appropriate tab.

Each tab has a (right-click) context menu.

Viewing tabs

If more tabs are open than will fit on the tab bar (depending on current sizing of Explorer++'s window and other panes), a set of scrolling buttons are available, allowing you to scroll left or right to view/select other tabs which are currently not visible.

Tip: The Tab bar may be extended to the full window width using an option.
Info: Hovering the mouse over a tab displays it's true location, regardless of the tab's title. Tab's opened at virtual folders show their CLSID (class ID), Windows' internal representation of their location. Practically, these CLSIDs are of no use, except to a programmer.

Opening new tabs

A new tab may be opened using a variety of methods, as listed here. From the Tab bar, the easiest methods may be

  • double-clicking empty space on the bar. This opens a file displaying the default contents.
  • using the tabs context menu

Closing tabs

When hovering the mouse over the "X" on the right side of the Tab bar, it becomes a "Close" button which will close the current tab. Tabs may also be closed by double-clicking on a tab, subject to an options setting. Other methods of closing a tab are:

  • from the File menu
  • from the tab's context menu. The tab need not be the current (ie. selected) tab.
Tip: Be careful closing tabs - the current tab may not be visible! A tab closed in error must be re-opened and re-configured, as necessary.

Re-arranging tabs

Tabs may re re-arranged using drag-and-drop, that is

  • click on a tab and hold the left mouse button down
  • move the cursor to the new (desired) position on the Tab bar
  • release the left mouse button

Moving files and folders

Files and folders in a tab's file view (ie. the Files pane) may be moved from one folder to another simply by dragging and dropping them onto a tab. If you pause slightly before dropping the items onto the tab, that tab will become active, but this is not necessary in order to complete the move.


Tab bar/Context-menu

Click or Hover on an item for more ...

Duplicate Tab

This item opens/creates a new tab on the tab bar, but duplicates the tab from which this item was called. Placement of the tab is dependent on an option setting.

Info: Duplicating a tab does not duplicate it's location history.

Open Parent in New Tab

This item opens/creates a new tab on the tab bar, using the location of the current folder's immediate parent. This is the folder that houses the current folder.

Info: The Desktop has no parent; this operation will not open a new tab if the current location is Desktop.

Refresh All

This item performs a refresh on all tabs currently open.

Rename Tab...

Ordinarily, a newly created tab assumes the name of the actual folder it displays (minus the drive and path information). This item, however, allows you to rename the tab to something more suitable to your needs. For example, while working on a programming project, you may have a tab open at "C:\Project\today\revisions\code", but other folders of the name "code" may also exist for that project (eg. different versions, dates). You can rename the folder to "Today's code" by selecting this item, choosing "Use custom name:" and typing in "Today's code". Renamed tabs are persistent, that is, they will remain renamed even during other sessions.
Info: On first opening the Rename Tab dialog, the "Use custom name:" setting is always selected as a convenience; it is assumed that you want to set a custom name.

Lock Tab

This item locks the tab, preventing it from being closed. The tab's icon is changed, and the menu item becomes checked, reminding the user that the tab is locked. Locked tabs can still be re-arranged or renamed. Locked tabs must be manually unlocked to restore default behavior. Tab locked status is preserved between sessions.

Lock Tab and Address

This item locks the tab, as above (ie. can't be closed), but also prevents the address from being changed by double-clicking on a folder or drive. A new tab is opened instead, displaying the desired new address.

Close Other Tabs

This item closes all tabs on the Tab bar except the tab whose context menu you are using, even if that tab is not active. Of course, when all other tabs are closed, the remaining tab becomes active.


Appendix A/SuperHidden Tool

This page contains a custom tool which uses ActiveX technology and JavaScript. If a pop-up message occurs which warns you of a security risk - it is SAFE to allow both.

Display of superhidden files - files or folders which have both the hidden and system attribute set - may be inhibited by a Windows registry setting. An Explorer++ Options setting may also be non-functional unless this registry setting is set to Show. Without this setting enabled, Explorer++ (since it uses Windows enumeration techniques) can display hidden files, but only those without the System attribute set.

The following tool may be used instead of the Control Panel applet (Folder Options) to enable display of superhidden files. This tool changes the setting of the registry key at

HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced\ShowSuperHidden

Use of the above buttons changes a registry setting for the current user; this may affect Windows Explorer and/or other Windows programs which rely on file visibility settings.

Explorer++ must be closed and re-opened (ie. restarted) for any changes to have an effect.


Appendix B/Accelerator, Shortcut keys

Appendix B/Accelerator, Modifier keys

Following is a list of Accelerator keys, etc. which are active in Explorer++. Some keys are also listed which are modifiers to mouse actions (ie. drag-and-drop).

Alphanumeric Keys | eg. A, B, 1, 2
Function Keys | eg. F1, F2
Page Navigation Keys | eg. Home, PageUp
Cursor Keys | Left, Right, Up
Editing Keys | Enter, Backspace, Tab
Miscellaneous Keys | Apps, [, ]
Mouse Keys, etc.

Alphanumeric Keys

 | MODIFIER KEYS |  |  |
KEY | +SHIFT | +CTRL | +ALT | FUNCTION
A |  | C |  | Select All
B |  | C |  | Organize Bookmarks
C |  | C |  | Copy
C | S | C |  | Copy to Folder
D |  | C |  | Bookmark This Tab
D | S | C |  | Wildcard Deselect
D |  |  | A | Select Address Bar
E |  | C |  | Duplicate Tab
F |  | C |  | Search
F | S | C |  | Set Filter
G |  | C |  | Apply Filter
H |  | C |  | Show Hidden Files
I |  | C |  | Invert Selection
L |  | C |  | Select Address Bar
M | S | C |  | Move To Folder
N |  | C |  | New Folder
N | S | C |  | Select None
P | S | C |  | Copy Folder Path (to clipboard)
R |  | C |  | Refresh
S | S | C |  | Wildcard Select
T |  | C |  | New Tab
V |  | C |  | Paste
V | S | C |  | Paste Shortcut
W |  | C |  | Close Tab
X |  | C |  | Cut
Z |  | C |  | Undo
1..8 |  | C |  | Select Tabs 1..8
9 |  | C |  | Select Last Tab

Function Keys

 | MODIFIER KEYS |  |  |
KEY | +SHIFT | +CTRL | +ALT | FUNCTION
F1 |  |  |  | Help
F2 |  |  |  | Rename
F2 |  |  |  | Cycle during Rename
F3 |  |  |  | Search
F4 |  |  |  | Address drop-down
F4 |  | C |  | Close Tab
F5 |  |  |  | Refresh
F6 |  |  |  | Next Pane
F6 | S |  |  | Previous Pane
F10 | S |  |  | Main Context Menu

Page Navigation Keys

 | MODIFIER KEYS |  |  |
KEY | +SHIFT | +CTRL | +ALT | FUNCTION
Delete |  |  |  | Delete
Delete | S |  |  | Delete Permanently
Home |  |  | A | Navigate to Default Folder
PageDown |  | C |  | Next Tab
PageUp |  | C |  | Previous Tab

Cursor Keys

 | MODIFIER KEYS |  |  |
KEY | +SHIFT | +CTRL | +ALT | FUNCTION
Left arrow |  |  | A | Back
Right arrow |  |  | A | Forward
Up arrow |  |  | A | Up One Level

Editing Keys

 | MODIFIER KEYS |  |  |
KEY | +SHIFT | +CTRL | +ALT | FUNCTION
Enter |  |  | A | Properties
Enter |  | C |  | Open Folder In New Tab
Backspace |  |  |  | Up One Level
Backspace |  | C |  | Root Folder of Tab
Tab |  |  |  | In Rename mode, start rename of next item
Tab |  |  |  | Next Pane
Tab | S |  |  | Previous Pane
Tab |  | C |  | Next Tab
Tab | S | C |  | Previous Tab

Miscellaneous Keys

 | MODIFIER KEYS |  |  |
KEY | +SHIFT | +CTRL | +ALT | FUNCTION
Win Apps |  |  |  | Main Context Menu
] |  | C |  | Next Tab
[ |  | C |  | Previous Tab

Windows Menu or Applications key

Mouse Keys, etc.

 | MODIFIER KEYS |  |  |
KEY | +SHIFT | +CTRL | +ALT | FUNCTION
 | S |  |  | Drag-and-Drop - force move
 |  | C |  | Drag-and-Drop - force copy
 | S | C |  | Drag-and-Drop - create shortcut(s)
 |  |  | A | Drag-and-Drop - create shortcut(s)
Double-Click |  | C |  | Open Folder In New Tab (in Files pane)
Double-Click |  |  | A | Properties (in Files pane)
Scroll | S |  |  | Back, Forward
Scroll |  | C |  | Cycle through Views


Appendix C/Regular Expression Reference

The Regular Expression elements below are a subset of TR1 Regular Expressions, used by the Search tool to match regular expressions to file/folder names. Some elements of the regular expression parser are not functional in that context (e.g. elements for detecting words boundaries, line ends, etc., elements for text replacement) and are for that reason, not included. Also, a few functional elements have no useful value here and have been omitted from the reference. The user of regular expressions is encouraged to experiment and discover any additional functionality embedded with the Search tool.

Some of the examples may not be ideally constructed - they are there just to demonstrate individual elements. Keep in mind that there is often more than one way to construct a regular expression which does a certain task.

Meta-characters

Meta-characters generally consist of the following characters: ˆ $ . * \ [ ] { } ( ) + ? |
Some meta-characters have more than one meaning, depending on their context (e.g. ^ as a negation symbol when used inside [], or as an anchor when used outside []). Using the escape character (\) immediately before a meta-character matches the character itself as a literal (no special meaning), for example \^ matches the actual "^" symbol when it occurs in the target (i.e. file/folder name) string.

Elements

The following table contains meta-characters and elements useful in the Search tool as part of regular expressions; there may also be additional useful information in the Regular Expressions Primer. Note that the case (i.e. upper/lower case) is important in some expressions (e.g. \s, \S).

EXPRESSION SYNTAX ORDINARY NAME DESCRIPTION EXAMPLES
Any character . dot or period matches any single character (except a newline - not used in file/folder names) s.s matches sys (system) and ses (session)
but not sores
Zero or more
(quantifier) 		* asterisk matches zero or more occurrences of the preceding expression, and makes all possible matches a*b matches b (bat) and ab (about)
.* matches any sequence of characters
Zero or one
(quantifier) 		? question mark matches zero or one occurrence of the preceding expression, same as {0,1} (see Repetition below)
One or more
(quantifier) 		+ plus matches at least one occurrence of the preceding expression, same as {1,} (see Repetition below) rol+ matches rol and rolllll
but not ro
Repetition
(quantifier) 		{n}
{min,max} 		braces In the first form, {n} matches n or more occurrences (n is inside the braces) of the preceding expression. In the second form, {min,max} matches at least min occurrences of the preceding expression, but not more than max occurrences. If max is omitted (e.g. {min,}) then the expression can match min or more occurrences (no upper limit). rol{2} matches roll and rolllll but not rol
z{2,3} matches zz and zzz but not zzzz
z{2,} matches zz and zzz, zzzz, etc.
Any one character in the set [] (square) brackets matches any one of the characters in the []. To specify a range of characters, list the starting and ending characters separated by a dash (-), as in [a-z]. Also see Character Classes below. be[srn]t matches best, bert or bent
Any one character not in the set [^...] circumflex accent,
exponent symbol 		matches any character that is not in the set of characters that follows the ^. Not that this symbol (^) has alternate meaning when used outside the square brackets. be[^r]t matches best or bent
but not bert
Or | pipe, vertical line matches either the expression before or the one after the OR symbol (|). Mostly used in a group. AL|TE matches ALE or ATE
Group () parentheses isolates an Or expression, also used by capture techniques a(jpg|jpeg) matches ajpg or ajpeg
Escape \ backslash when it precedes a meta-character, the combination is taken as a literal. Some meta-characters, namely ˆ$.[]{}()+, may be used in file/folder names. To match the actual "\" character, escape it as you would any other character (e.g. \\). This symbol, however, is forbidden for use in a Windows file or folder name (used in path construction). a\.txt matches a.txt
Any one whitespace character \s backslash s matches a single whitespace character (space, tab, newline). Note: tab and newline cannot used in file/folder names. s is actually a class ([:space:] or [:s:]), but is not listed under classes; use this syntax instead. hi\sbob matches hi bob
but not hi-bob
Any one non-whitespace character \S backslash S matches a single non-whitespace character. hi\Sbob matches hi-bob
but not hi bob
Any one digit \d backslash d matches a single numeric character. This is the same as using [0-9]. See classes below. file\d matches file2 and file9
but not files
Any one non-digit \D backslash D matches a single non-numeric character. This is the same as using [^0-9]. file\D matches files and filed
but not file1
Any alphanumeric
(word character) 		\w backslash w matches a single alphanumeric character (a-z, A-Z, 0-9). See classes below. 1234\w matches 12345 and 1234a
but not 1234!
Any non-alphanumeric
(non-word character) 		\W backslash W matches a single non-alphanumeric character 1234\W matches 1234!
but not 12345 or 1234a
One Unicode character \u#### backslash u, 4 hex digits matches a single Unicode character. #### represents 4 hexadecimal digits - the character code; hex digits in the A-F range may be upper or lower case. flamb\u00E9 matches flambé
but not flambe

Anchors

Anchors are elements which match specific locations in the target string. Knowing that the search pattern has arrived at one of these locations might be useful in narrowing down the search by incorporating that location into the regular expression. Anchors have zero width, that is, they do not advance the text pointer in the target string.

EXPRESSION SYNTAX ORDINARY NAME DESCRIPTION EXAMPLES
Word boundary \b backslash b

matches when the current position in the target string is immediately after a word boundary. In other words, at this point, there is a word (alphanumeric) character on one side of the pointer, but not on the other. This might be

  • at the start of the file name
  • at a space in the file name
  • at a "." character anywhere in the name, or at the start of the file extension

The "\b" element matches either a start or end of a word.

.*\bhp.* matches "abc hp.txt", "hp abc.txt", "hp.txt" and "hpabc.txt"
but not "abchp.txt"
Non-word boundary \B backslash \B matches when the current position in the target string is not a word boundary (see \b above) .*\Bhp.* matches "abchp.txt"
but not all the others matched in \b above
String start ^ circumflex accent,
exponent symbol 		matches when the current position is the start of the string .*^ex.* matches explorer.htm
but not index.htm
String end $ dollar sign matches when the current position is the end of the string .*hp$.* matches abchp and hp
but not hpabc

Character Classes

Character classes are a shorthand way of representing a range of characters and may be used directly in the construction of character sets (or negation sets, e.g. [^...]) in regular expressions. Each class below is shown in usable form - they require delimiting ":" characters, and must be enclosed in brackets. They may then be used in character sets - as if they were a single character - which requires double sets of brackets (see examples below). Using classes may reduce the size of your expression, but the same functionality can be added in other ways. Note: that classes are locale dependent and may include foreign language characters which are in common locale usage, e.g. é; to exclude those characters, use a constructed character set instead, such as [a-zA-Z]. A few select classes have short names, e.g. see digits and alphanumeric below, and \s in expressions above.

CLASS | SYNTAX | DESCRIPTION | EXAMPLES
uppercase [:upper:] upper case characters [[:upper:]]* matches FILE
but not File
lowercase [:lower:] lower case characters [[:lower:]]* matches file
but not File
alphabetic [:alpha:] all upper/lower case letters [[:alpha:]]* matches abgh
but not doc1
digits [:digit:]
[:d:] 		ordinary digits 0-9, alternate syntax is [:d:] [[:digit:]]* matches 134679
but not 134679a
hexadecimal digits [:xdigit:] all hex digits, i.e. a-f, A-F, 0-9 [[:xdigit:]]* matches 1a2b9F
but not 1g4b
alphanumeric [:alnum:]
[:w:] 		all upper/lower case letters, digits 0-9, alternate syntax is [:w:] [[:alnum:]]* matches 12ex and flambé
but not 87_a or 12ex.txt
punctuation [:punct:] punctuation [[:punct:]]* matches _!~.@@
but not _!~.@@.txt
[:graph:] upper/lower case letters, digits, and punctuation [[:graph:]]* matches textdoc.txt
but not text doc.txt
[:print:] | upper/lower case letters, digits, punctuation and space | same as . - matches every character

Capture Groups

If an element matches a portion of the target string, the characters that it matched (in the target string) may be captured and re-used in the same regular expression. Capture is accomplished by

  • forming the capturing element inside parentheses, e.g. (.) captures a single character then
  • using escape (\) followed by an integer to represent the captured text. Integers start at 1 (left-most or first capture) and increase as captures are done (left to right).

For example, the regular expression
    ab(.{2})(.{2})(.{2})\1\2\3
may be broken down as follows:

ab | literal | matches "ab" as the first 2 characters in the target string
(.{2}) | wildcard x 2 | matches and captures the next 2 characters, i.e. 3-4
(.{2}) | wildcard x 2 | matches and captures the next 2 characters, i.e. 5-6
(.{2}) | wildcard x 2 | matches and captures the next 2 characters, i.e. 7-8
\1 | capture group 1 | represents characters 3-4 in the target string, and tries to match them starting at character 9 (i.e. 9-10)
\2 | capture group 2 | represents characters 5-6 in the target string, and tries to match them starting at character 11 (i.e. 11-12)
\3 | capture group 3 | represents characters 7-8 in the target string, and tries to match them starting at character 11 (i.e. 11-12)

This expression matches the file named ab12ed4f12ed4f, but not the file named ab12ed4f12ed4g (the 2 character repeating patterns are not satisfied at the last character).

Concatenation

Regular expression elements, with or without repetition counts, can be concatenated to form longer regular expressions, simply by writing the individual elements concurrently. The resulting expression is a result of applying the individual elements, in sequence left to right, in order to determine a match.

Example: the expression a+(b|c){2,}\.doc is a result of concatenating

● | a+ | match one or more "a"s, then
● | (b|c){2,} | match "b" or "c", 2 or more times, then
● | \. | match the "." (dot) character (part of the file extension), then
● | doc | match "doc"

This expression would match file names of acc.doc and abbb.doc, but would not match acc.txt or ac.doc.


Contents

Use this Table of Contents when the navigation pane (Contents, Search, Index) is not visible. An Index is also available.

Your Internet Options settings (Security) may block the TOC below; it is it is safe to allow ActiveX used by the TOC.


Index

Use this Index when the navigation pane (Contents, Search, Index) is not visible. A Table of Contents is also available.

Your Internet Options settings (Security) may block the Index below; it is it is safe to allow ActiveX used by the Index.


PLACEHOLDER ONLY!

Placeholder

Incomplete: This page is only a placeholder for a topic which is not yet written - used for navigation testing only. Future versions of this help file will have content here instead!

Sorry, the [image] button will probably not take you back to where you came from (html restriction!).
Click on one of the following links instead...

  • Explorer++ Help Navigation

  • Options

    • General

    • Files and Folders

    • Window

    • Tabs


Directory
---------
H:\Projects\Explorer++\html\mnu_file

Date
----
2011-10-30, 7:39:58 AM

Statistics
----------
Number of folders: 0
Number of files: 15
Total size (not including subfolders): 42.7 KB

Folders
-------

Files
-----
clone_win.htm
close_tab.htm
copy_col_text.htm
copy_file_paths.htm
copy_folder_path.htm
copy_Ufile_paths.htm
delete.htm
delete_perm.htm
exit.htm
new_tab.htm
properties.htm
rename.htm
save_dir_list.htm
set_file_attr.htm
show_cmd_prompt.htm


                    GNU GENERAL PUBLIC LICENSE
                       Version 3, 29 June 2007

 Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

                            Preamble

  The GNU General Public License is a free, copyleft license for
software and other kinds of works.

  The licenses for most software and other practical works are designed
to take away your freedom to share and change the works.  By contrast,
the GNU General Public License is intended to guarantee your freedom to
share and change all versions of a program--to make sure it remains free
software for all its users.  We, the Free Software Foundation, use the
GNU General Public License for most of our software; it applies also to
any other work released this way by its authors.  You can apply it to
your programs, too.

  When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
them if you wish), that you receive source code or can get it if you
want it, that you can change the software or use pieces of it in new
free programs, and that you know you can do these things.

  To protect your rights, we need to prevent others from denying you
these rights or asking you to surrender the rights.  Therefore, you have
certain responsibilities if you distribute copies of the software, or if
you modify it: responsibilities to respect the freedom of others.

  For example, if you distribute copies of such a program, whether
gratis or for a fee, you must pass on to the recipients the same
freedoms that you received.  You must make sure that they, too, receive
or can get the source code.  And you must show them these terms so they
know their rights.

  Developers that use the GNU GPL protect your rights with two steps:
(1) assert copyright on the software, and (2) offer you this License
giving you legal permission to copy, distribute and/or modify it.

  For the developers' and authors' protection, the GPL clearly explains
that there is no warranty for this free software.  For both users' and
authors' sake, the GPL requires that modified versions be marked as
changed, so that their problems will not be attributed erroneously to
authors of previous versions.

  Some devices are designed to deny users access to install or run
modified versions of the software inside them, although the manufacturer
can do so.  This is fundamentally incompatible with the aim of
protecting users' freedom to change the software.  The systematic
pattern of such abuse occurs in the area of products for individuals to
use, which is precisely where it is most unacceptable.  Therefore, we
have designed this version of the GPL to prohibit the practice for those
products.  If such problems arise substantially in other domains, we
stand ready to extend this provision to those domains in future versions
of the GPL, as needed to protect the freedom of users.

  Finally, every program is threatened constantly by software patents.
States should not allow patents to restrict development and use of
software on general-purpose computers, but in those that do, we wish to
avoid the special danger that patents applied to a free program could
make it effectively proprietary.  To prevent this, the GPL assures that
patents cannot be used to render the program non-free.

  The precise terms and conditions for copying, distribution and
modification follow.

                       TERMS AND CONDITIONS

  0. Definitions.

  "This License" refers to version 3 of the GNU General Public License.

  "Copyright" also means copyright-like laws that apply to other kinds of
works, such as semiconductor masks.

  "The Program" refers to any copyrightable work licensed under this
License.  Each licensee is addressed as "you".  "Licensees" and
"recipients" may be individuals or organizations.

  To "modify" a work means to copy from or adapt all or part of the work
in a fashion requiring copyright permission, other than the making of an
exact copy.  The resulting work is called a "modified version" of the
earlier work or a work "based on" the earlier work.

  A "covered work" means either the unmodified Program or a work based
on the Program.

  To "propagate" a work means to do anything with it that, without
permission, would make you directly or secondarily liable for
infringement under applicable copyright law, except executing it on a
computer or modifying a private copy.  Propagation includes copying,
distribution (with or without modification), making available to the
public, and in some countries other activities as well.

  To "convey" a work means any kind of propagation that enables other
parties to make or receive copies.  Mere interaction with a user through
a computer network, with no transfer of a copy, is not conveying.

  An interactive user interface displays "Appropriate Legal Notices"
to the extent that it includes a convenient and prominently visible
feature that (1) displays an appropriate copyright notice, and (2)
tells the user that there is no warranty for the work (except to the
extent that warranties are provided), that licensees may convey the
work under this License, and how to view a copy of this License.  If
the interface presents a list of user commands or options, such as a
menu, a prominent item in the list meets this criterion.

  1. Source Code.

  The "source code" for a work means the preferred form of the work
for making modifications to it.  "Object code" means any non-source
form of a work.

  A "Standard Interface" means an interface that either is an official
standard defined by a recognized standards body, or, in the case of
interfaces specified for a particular programming language, one that
is widely used among developers working in that language.

  The "System Libraries" of an executable work include anything, other
than the work as a whole, that (a) is included in the normal form of
packaging a Major Component, but which is not part of that Major
Component, and (b) serves only to enable use of the work with that
Major Component, or to implement a Standard Interface for which an
implementation is available to the public in source code form.  A
"Major Component", in this context, means a major essential component
(kernel, window system, and so on) of the specific operating system
(if any) on which the executable work runs, or a compiler used to
produce the work, or an object code interpreter used to run it.

  The "Corresponding Source" for a work in object code form means all
the source code needed to generate, install, and (for an executable
work) run the object code and to modify the work, including scripts to
control those activities.  However, it does not include the work's
System Libraries, or general-purpose tools or generally available free
programs which are used unmodified in performing those activities but
which are not part of the work.  For example, Corresponding Source
includes interface definition files associated with source files for
the work, and the source code for shared libraries and dynamically
linked subprograms that the work is specifically designed to require,
such as by intimate data communication or control flow between those
subprograms and other parts of the work.

  The Corresponding Source need not include anything that users
can regenerate automatically from other parts of the Corresponding
Source.

  The Corresponding Source for a work in source code form is that
same work.

  2. Basic Permissions.

  All rights granted under this License are granted for the term of
copyright on the Program, and are irrevocable provided the stated
conditions are met.  This License explicitly affirms your unlimited
permission to run the unmodified Program.  The output from running a
covered work is covered by this License only if the output, given its
content, constitutes a covered work.  This License acknowledges your
rights of fair use or other equivalent, as provided by copyright law.

  You may make, run and propagate covered works that you do not
convey, without conditions so long as your license otherwise remains
in force.  You may convey covered works to others for the sole purpose
of having them make modifications exclusively for you, or provide you
with facilities for running those works, provided that you comply with
the terms of this License in conveying all material for which you do
not control copyright.  Those thus making or running the covered works
for you must do so exclusively on your behalf, under your direction
and control, on terms that prohibit them from making any copies of
your copyrighted material outside their relationship with you.

  Conveying under any other circumstances is permitted solely under
the conditions stated below.  Sublicensing is not allowed; section 10
makes it unnecessary.

  3. Protecting Users' Legal Rights From Anti-Circumvention Law.

  No covered work shall be deemed part of an effective technological
measure under any applicable law fulfilling obligations under article
11 of the WIPO copyright treaty adopted on 20 December 1996, or
similar laws prohibiting or restricting circumvention of such
measures.

  When you convey a covered work, you waive any legal power to forbid
circumvention of technological measures to the extent such circumvention
is effected by exercising rights under this License with respect to
the covered work, and you disclaim any intention to limit operation or
modification of the work as a means of enforcing, against the work's
users, your or third parties' legal rights to forbid circumvention of
technological measures.

  4. Conveying Verbatim Copies.

  You may convey verbatim copies of the Program's source code as you
receive it, in any medium, provided that you conspicuously and
appropriately publish on each copy an appropriate copyright notice;
keep intact all notices stating that this License and any
non-permissive terms added in accord with section 7 apply to the code;
keep intact all notices of the absence of any warranty; and give all
recipients a copy of this License along with the Program.

  You may charge any price or no price for each copy that you convey,
and you may offer support or warranty protection for a fee.

  5. Conveying Modified Source Versions.

  You may convey a work based on the Program, or the modifications to
produce it from the Program, in the form of source code under the
terms of section 4, provided that you also meet all of these conditions:

    a) The work must carry prominent notices stating that you modified
    it, and giving a relevant date.

    b) The work must carry prominent notices stating that it is
    released under this License and any conditions added under section
    7.  This requirement modifies the requirement in section 4 to
    "keep intact all notices".

    c) You must license the entire work, as a whole, under this
    License to anyone who comes into possession of a copy.  This
    License will therefore apply, along with any applicable section 7
    additional terms, to the whole of the work, and all its parts,
    regardless of how they are packaged.  This License gives no
    permission to license the work in any other way, but it does not
    invalidate such permission if you have separately received it.

    d) If the work has interactive user interfaces, each must display
    Appropriate Legal Notices; however, if the Program has interactive
    interfaces that do not display Appropriate Legal Notices, your
    work need not make them do so.

  A compilation of a covered work with other separate and independent
works, which are not by their nature extensions of the covered work,
and which are not combined with it such as to form a larger program,
in or on a volume of a storage or distribution medium, is called an
"aggregate" if the compilation and its resulting copyright are not
used to limit the access or legal rights of the compilation's users
beyond what the individual works permit.  Inclusion of a covered work
in an aggregate does not cause this License to apply to the other
parts of the aggregate.

  6. Conveying Non-Source Forms.

  You may convey a covered work in object code form under the terms
of sections 4 and 5, provided that you also convey the
machine-readable Corresponding Source under the terms of this License,
in one of these ways:

    a) Convey the object code in, or embodied in, a physical product
    (including a physical distribution medium), accompanied by the
    Corresponding Source fixed on a durable physical medium
    customarily used for software interchange.

    b) Convey the object code in, or embodied in, a physical product
    (including a physical distribution medium), accompanied by a
    written offer, valid for at least three years and valid for as
    long as you offer spare parts or customer support for that product
    model, to give anyone who possesses the object code either (1) a
    copy of the Corresponding Source for all the software in the
    product that is covered by this License, on a durable physical
    medium customarily used for software interchange, for a price no
    more than your reasonable cost of physically performing this
    conveying of source, or (2) access to copy the
    Corresponding Source from a network server at no charge.

    c) Convey individual copies of the object code with a copy of the
    written offer to provide the Corresponding Source.  This
    alternative is allowed only occasionally and noncommercially, and
    only if you received the object code with such an offer, in accord
    with subsection 6b.

    d) Convey the object code by offering access from a designated
    place (gratis or for a charge), and offer equivalent access to the
    Corresponding Source in the same way through the same place at no
    further charge.  You need not require recipients to copy the
    Corresponding Source along with the object code.  If the place to
    copy the object code is a network server, the Corresponding Source
    may be on a different server (operated by you or a third party)
    that supports equivalent copying facilities, provided you maintain
    clear directions next to the object code saying where to find the
    Corresponding Source.  Regardless of what server hosts the
    Corresponding Source, you remain obligated to ensure that it is
    available for as long as needed to satisfy these requirements.

    e) Convey the object code using peer-to-peer transmission, provided
    you inform other peers where the object code and Corresponding
    Source of the work are being offered to the general public at no
    charge under subsection 6d.

  A separable portion of the object code, whose source code is excluded
from the Corresponding Source as a System Library, need not be
included in conveying the object code work.

  A "User Product" is either (1) a "consumer product", which means any
tangible personal property which is normally used for personal, family,
or household purposes, or (2) anything designed or sold for incorporation
into a dwelling.  In determining whether a product is a consumer product,
doubtful cases shall be resolved in favor of coverage.  For a particular
product received by a particular user, "normally used" refers to a
typical or common use of that class of product, regardless of the status
of the particular user or of the way in which the particular user
actually uses, or expects or is expected to use, the product.  A product
is a consumer product regardless of whether the product has substantial
commercial, industrial or non-consumer uses, unless such uses represent
the only significant mode of use of the product.

  "Installation Information" for a User Product means any methods,
procedures, authorization keys, or other information required to install
and execute modified versions of a covered work in that User Product from
a modified version of its Corresponding Source.  The information must
suffice to ensure that the continued functioning of the modified object
code is in no case prevented or interfered with solely because
modification has been made.

  If you convey an object code work under this section in, or with, or
specifically for use in, a User Product, and the conveying occurs as
part of a transaction in which the right of possession and use of the
User Product is transferred to the recipient in perpetuity or for a
fixed term (regardless of how the transaction is characterized), the
Corresponding Source conveyed under this section must be accompanied
by the Installation Information.  But this requirement does not apply
if neither you nor any third party retains the ability to install
modified object code on the User Product (for example, the work has
been installed in ROM).

  The requirement to provide Installation Information does not include a
requirement to continue to provide support service, warranty, or updates
for a work that has been modified or installed by the recipient, or for
the User Product in which it has been modified or installed.  Access to a
network may be denied when the modification itself materially and
adversely affects the operation of the network or violates the rules and
protocols for communication across the network.

  Corresponding Source conveyed, and Installation Information provided,
in accord with this section must be in a format that is publicly
documented (and with an implementation available to the public in
source code form), and must require no special password or key for
unpacking, reading or copying.

  7. Additional Terms.

  "Additional permissions" are terms that supplement the terms of this
License by making exceptions from one or more of its conditions.
Additional permissions that are applicable to the entire Program shall
be treated as though they were included in this License, to the extent
that they are valid under applicable law.  If additional permissions
apply only to part of the Program, that part may be used separately
under those permissions, but the entire Program remains governed by
this License without regard to the additional permissions.

  When you convey a copy of a covered work, you may at your option
remove any additional permissions from that copy, or from any part of
it.  (Additional permissions may be written to require their own
removal in certain cases when you modify the work.)  You may place
additional permissions on material, added by you to a covered work,
for which you have or can give appropriate copyright permission.

  Notwithstanding any other provision of this License, for material you
add to a covered work, you may (if authorized by the copyright holders of
that material) supplement the terms of this License with terms:

    a) Disclaiming warranty or limiting liability differently from the
    terms of sections 15 and 16 of this License; or

    b) Requiring preservation of specified reasonable legal notices or
    author attributions in that material or in the Appropriate Legal
    Notices displayed by works containing it; or

    c) Prohibiting misrepresentation of the origin of that material, or
    requiring that modified versions of such material be marked in
    reasonable ways as different from the original version; or

    d) Limiting the use for publicity purposes of names of licensors or
    authors of the material; or

    e) Declining to grant rights under trademark law for use of some
    trade names, trademarks, or service marks; or

    f) Requiring indemnification of licensors and authors of that
    material by anyone who conveys the material (or modified versions of
    it) with contractual assumptions of liability to the recipient, for
    any liability that these contractual assumptions directly impose on
    those licensors and authors.

  All other non-permissive additional terms are considered "further
restrictions" within the meaning of section 10.  If the Program as you
received it, or any part of it, contains a notice stating that it is
governed by this License along with a term that is a further
restriction, you may remove that term.  If a license document contains
a further restriction but permits relicensing or conveying under this
License, you may add to a covered work material governed by the terms
of that license document, provided that the further restriction does
not survive such relicensing or conveying.

  If you add terms to a covered work in accord with this section, you
must place, in the relevant source files, a statement of the
additional terms that apply to those files, or a notice indicating
where to find the applicable terms.

  Additional terms, permissive or non-permissive, may be stated in the
form of a separately written license, or stated as exceptions;
the above requirements apply either way.

  8. Termination.

  You may not propagate or modify a covered work except as expressly
provided under this License.  Any attempt otherwise to propagate or
modify it is void, and will automatically terminate your rights under
this License (including any patent licenses granted under the third
paragraph of section 11).

  However, if you cease all violation of this License, then your
license from a particular copyright holder is reinstated (a)
provisionally, unless and until the copyright holder explicitly and
finally terminates your license, and (b) permanently, if the copyright
holder fails to notify you of the violation by some reasonable means
prior to 60 days after the cessation.

  Moreover, your license from a particular copyright holder is
reinstated permanently if the copyright holder notifies you of the
violation by some reasonable means, this is the first time you have
received notice of violation of this License (for any work) from that
copyright holder, and you cure the violation prior to 30 days after
your receipt of the notice.

  Termination of your rights under this section does not terminate the
licenses of parties who have received copies or rights from you under
this License.  If your rights have been terminated and not permanently
reinstated, you do not qualify to receive new licenses for the same
material under section 10.

  9. Acceptance Not Required for Having Copies.

  You are not required to accept this License in order to receive or
run a copy of the Program.  Ancillary propagation of a covered work
occurring solely as a consequence of using peer-to-peer transmission
to receive a copy likewise does not require acceptance.  However,
nothing other than this License grants you permission to propagate or
modify any covered work.  These actions infringe copyright if you do
not accept this License.  Therefore, by modifying or propagating a
covered work, you indicate your acceptance of this License to do so.

  10. Automatic Licensing of Downstream Recipients.

  Each time you convey a covered work, the recipient automatically
receives a license from the original licensors, to run, modify and
propagate that work, subject to this License.  You are not responsible
for enforcing compliance by third parties with this License.

  An "entity transaction" is a transaction transferring control of an
organization, or substantially all assets of one, or subdividing an
organization, or merging organizations.  If propagation of a covered
work results from an entity transaction, each party to that
transaction who receives a copy of the work also receives whatever
licenses to the work the party's predecessor in interest had or could
give under the previous paragraph, plus a right to possession of the
Corresponding Source of the work from the predecessor in interest, if
the predecessor has it or can get it with reasonable efforts.

  You may not impose any further restrictions on the exercise of the
rights granted or affirmed under this License.  For example, you may
not impose a license fee, royalty, or other charge for exercise of
rights granted under this License, and you may not initiate litigation
(including a cross-claim or counterclaim in a lawsuit) alleging that
any patent claim is infringed by making, using, selling, offering for
sale, or importing the Program or any portion of it.

  11. Patents.

  A "contributor" is a copyright holder who authorizes use under this
License of the Program or a work on which the Program is based.  The
work thus licensed is called the contributor's "contributor version".

  A contributor's "essential patent claims" are all patent claims
owned or controlled by the contributor, whether already acquired or
hereafter acquired, that would be infringed by some manner, permitted
by this License, of making, using, or selling its contributor version,
but do not include claims that would be infringed only as a
consequence of further modification of the contributor version.  For
purposes of this definition, "control" includes the right to grant
patent sublicenses in a manner consistent with the requirements of
this License.

  Each contributor grants you a non-exclusive, worldwide, royalty-free
patent license under the contributor's essential patent claims, to
make, use, sell, offer for sale, import and otherwise run, modify and
propagate the contents of its contributor version.

  In the following three paragraphs, a "patent license" is any express
agreement or commitment, however denominated, not to enforce a patent
(such as an express permission to practice a patent or covenant not to
sue for patent infringement).  To "grant" such a patent license to a
party means to make such an agreement or commitment not to enforce a
patent against the party.

  If you convey a covered work, knowingly relying on a patent license,
and the Corresponding Source of the work is not available for anyone
to copy, free of charge and under the terms of this License, through a
publicly available network server or other readily accessible means,
then you must either (1) cause the Corresponding Source to be so
available, or (2) arrange to deprive yourself of the benefit of the
patent license for this particular work, or (3) arrange, in a manner
consistent with the requirements of this License, to extend the patent
license to downstream recipients.  "Knowingly relying" means you have
actual knowledge that, but for the patent license, your conveying the
covered work in a country, or your recipient's use of the covered work
in a country, would infringe one or more identifiable patents in that
country that you have reason to believe are valid.

  If, pursuant to or in connection with a single transaction or
arrangement, you convey, or propagate by procuring conveyance of, a
covered work, and grant a patent license to some of the parties
receiving the covered work authorizing them to use, propagate, modify
or convey a specific copy of the covered work, then the patent license
you grant is automatically extended to all recipients of the covered
work and works based on it.

  A patent license is "discriminatory" if it does not include within
the scope of its coverage, prohibits the exercise of, or is
conditioned on the non-exercise of one or more of the rights that are
specifically granted under this License.  You may not convey a covered
work if you are a party to an arrangement with a third party that is
in the business of distributing software, under which you make payment
to the third party based on the extent of your activity of conveying
the work, and under which the third party grants, to any of the
parties who would receive the covered work from you, a discriminatory
patent license (a) in connection with copies of the covered work
conveyed by you (or copies made from those copies), or (b) primarily
for and in connection with specific products or compilations that
contain the covered work, unless you entered into that arrangement,
or that patent license was granted, prior to 28 March 2007.

  Nothing in this License shall be construed as excluding or limiting
any implied license or other defenses to infringement that may
otherwise be available to you under applicable patent law.

  12. No Surrender of Others' Freedom.

  If conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License.  If you cannot convey a
covered work so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you may
not convey it at all.  For example, if you agree to terms that obligate you
to collect a royalty for further conveying from those to whom you convey
the Program, the only way you could satisfy both those terms and this
License would be to refrain entirely from conveying the Program.

  13. Use with the GNU Affero General Public License.

  Notwithstanding any other provision of this License, you have
permission to link or combine any covered work with a work licensed
under version 3 of the GNU Affero General Public License into a single
combined work, and to convey the resulting work.  The terms of this
License will continue to apply to the part which is the covered work,
but the special requirements of the GNU Affero General Public License,
section 13, concerning interaction through a network will apply to the
combination as such.

  14. Revised Versions of this License.

  The Free Software Foundation may publish revised and/or new versions of
the GNU General Public License from time to time.  Such new versions will
be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.

  Each version is given a distinguishing version number.  If the
Program specifies that a certain numbered version of the GNU General
Public License "or any later version" applies to it, you have the
option of following the terms and conditions either of that numbered
version or of any later version published by the Free Software
Foundation.  If the Program does not specify a version number of the
GNU General Public License, you may choose any version ever published
by the Free Software Foundation.

  If the Program specifies that a proxy can decide which future
versions of the GNU General Public License can be used, that proxy's
public statement of acceptance of a version permanently authorizes you
to choose that version for the Program.

  Later license versions may give you additional or different
permissions.  However, no additional obligations are imposed on any
author or copyright holder as a result of your choosing to follow a
later version.

  15. Disclaimer of Warranty.

  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

  16. Limitation of Liability.

  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGES.

  17. Interpretation of Sections 15 and 16.

  If the disclaimer of warranty and limitation of liability provided
above cannot be given local legal effect according to their terms,
reviewing courts shall apply local law that most closely approximates
an absolute waiver of all civil liability in connection with the
Program, unless a warranty or assumption of liability accompanies a
copy of the Program in return for a fee.

                     END OF TERMS AND CONDITIONS


Options/Default Columns...

Tools/Options.../Default Columns...

System Default: see Folder types, varies with type

You may set the columns (and column order) to be shown on new tabs; default column widths are always reset to 150 pixels. Default column widths may be changed, however, by the Save Column Layout as Default menu item.

About Default Columns and Column Widths

Info: Explorer++ keeps 2 different sets of default columns for use, each with its own column order, visibility and column widths for the 7 different types of folders.
  • one set of system defaults. This set is the set used to create new tabs. It can be altered by the Default Columns... setting (this setting - column order and visibility only) and the Save Column Layout as Default setting (order, visibility and width). Column widths are only changed when the current tab layout is saved as default. New tabs, when created, adopt this set of columns and widths. These settings are persistent, maintained in either the config.xml file or the Windows registry.
  • one set for each tab. This set is used when the tab is switched to one of the 7 different types of folders, but is never used for another tab. Column display settings and width changes are only maintained for this tab. If the Save Column Layout as Default option is used, the current column settings and widths (this type of folder only) is saved to the system defaults. Once the tab is closed, these settings are lost.


Options/Show user friendly dates

Tools/Options.../Show user friendly dates

System Default: Yes

Setting this option presents the

  • Date Created,
  • Date Modified and
  • Date Accessed

columns in the Files pane with user friendly dates, such as "Today, time" and 'Yesterday, time" instead of the usual format. The usual format is determined by your system settings for Date and Time display and can be modified in the Regional and Language Options Control Panel applet.

You may open the Control Panel applet here: to customize your settings (Short Date format, Time).

Incomplete: To date, only "Today" and "Yesterday" have been implemented as user friendly dates.


Options/Show all file sizes in:

Tools/Options.../Show all file sizes in:

System Default: Flexible, Bytes if option enabled

When this box is cleared, drive and file sizes (and folder sizes, if enabled) are displayed in a flexible format, that is, in bytes, kilobytes (KB - 103 bytes), megabytes (MB - 106 bytes), etc., depending on file size.

Checking the box allows the user to choose from a variety of units, from bytes up to terabytes (1012 bytes) and even petabytes (1015 bytes)! File sizes will be displayed in the chosen units, even if files are small. This might prove useful in viewing the sizes of larger drives, etc. or media files (DVD files could be in the gigabyte (109 bytes) range


Options/Insert new items in their sorted positions

Tools/Options.../Insert new items in their sorted positions

System Default: Yes

Explorer++ sorts items in the current Files pane (ie. tab) when a Refresh is done, or when refreshing is done automatically by changing the column sorting, etc. When new items are added to the tab by drag-and-drop, or by using the New item of the context (right-click) menu, newly added items are (by default) inserted in the correct location - folders at the top (or bottom, depending on the column header status), files in position by alphabetic order. Disabling this option, however, causes all new items to be placed at the bottom the of current list. This may be of benefit when editing folders, etc. and new files/folders can be determined at a glance.

Of course, automatic refresh (and sorting) is still done when column sorting is changed and at startup, etc.


Options/Show folder sizes

Tools/Options.../Show folder sizes

System Default: No

Checking this box forces Explorer++ to calculate and display folder sizes in the Files pane. The feature might be useful if, for example, you were house-cleaning your drive and wanted to merge smaller folders with larger ones; folder sizes would be listed is the Size column, if enabled.

Caution: Although it sounds obvious, when this option is enabled, Explorer++ calculates folder sizes - always. If you are walking through your folder tree to get to a particular location, large folders in the files pane will be calculated, even if they are only momentarily displayed. Windows is a multi-tasking, multi-threaded operating system; calculations continue even though the folder is no longer displayed. This may greatly impact your system's performance - use this option with care.

Disable folder sizes on removable and network drives

When folder size calculation and display is enabled, you may check this box to turn off the feature for removable and network drives, as a time-saving convenience. For network drives, this is a safety feature, as the system may not know ahead of time just how large the network drive is; time will be saved. In addition, network and removable drives are transitory - it may not be useful to know the sizes since tomorrow, the drives may not be connected.


Options/Single-click to open an item

Tools/Options.../Single-click to open an item

System Default: No

Windows' default mode of operation (in most situations) is

  • single-click on an item to select it (give it focus)
  • double-click to activate it or execute it

The X Window System graphical user interface, popular with Unix/Linux-type operating systems, uses a different approach

  • hover over an item to select it (give it focus)
  • click once to activate it or execute it

Enabling this option causes Explorer++ to behave like an X Window application - in the Files pane only. Some users may find this more comfortable (less mouse clicks) or faster.

Hover time (ms)

incomplete

Info: This behavior is available in Windows as a system-wide setting. The General page of the Folder Options Control Panel applet provides this functionality. Explorer++, as it is not a native Windows component, does not obey this setting.


Options/Default new tab folder

Tools/Options.../Default new tab folder

System Default: My Computer

This option allows the user to select a default folder to be used when a new tab is opened. The option presents a typical Windows Browse For Folder dialog, allowing the user to choose a folder. Prior to using this option, the default folder is My Computer.

If a folder is set by this option, then subsequently is renamed or deleted (ie. folder cannot be found), new tabs default back to My Computer.

Tip: The Browse For Folder dialog is an native Windows dialog and, as such, respects the settings from the Control Panel/Folder Options - View tab. Specifically, the

  • Do not show hidden files and folders, and the

  • Hide protected operating system files (Recommended) setting

if enabled will prevent display of some folders by this dialog. This behavior exists even if Explorer++ is set to display hidden items, since Explorer++ has no control over this dialog.

It is recommended that both of the above settings be changed to display all files and folders when using Explorer++, and to use its own control of these attributes.


Options/Language

Tools/Options.../Language

System Default: English (9) - internal

Explorer++ is a native English language application, but International users have contributed translation DLLs which, when placed in the installation folder, present the menus, etc. in a different language. The DLLs are not shipped with Explorer++, but may be downloaded from the translation page of Explorer++'s site at

http://www.explorerplusplus.com/translations

Once the DLLs are placed in the Explorer++ installation folder, the languages will appear as choices on the language drop-down (or drop-up!) control for this option. You may need to install additional fonts, or East-Asian language support prior to using some alternate languages.

The translations are incomplete, but are an excellent start to the globalization of Explorer++.

As of this version, the status of translations available is as follows:

Language Code
(ISO 639-1) 		Lang. #
(Windows) 		Appears as
(in drop-down) 		Completion
(approximate)
Catalan | CA | 0x03 | 91%
Czech | CS | 0x05 | 74%
Danish | DA | 0x06 | 100%
German | DE | 0x07 | 91%
English | EN | 0x09 | 100% (internal)
Spanish | ES | 0x0A | 100%
Farsi (Persian) | FA | 0x29 | 100%
French | FR | 0x0C | 97%
Italian | IT | 0x10 | 98%
Japanese1 | JA | 0x11 | 49%
Korean1 | KO | 0x12 | 92%
Dutch | NL | 0x13 | 94%
Norwegian | NO | 0x14 | 93%
Polish | PL | 0x15 | 97%
Portuguese | PT | 0x16 | 95%
Romanian | RO | 0x18 | 73%
Russian | RU | 0x19 | 93%
Sinhala (Sri Lanka)2 | SI | 0x5B | 48%
Turkish | TR | 0x1F | 86%
Ukrainian | UK | 0x22 | 90%
Chinese (Simplified)1 | ZH | 0x04 | 92%
Notes:
  1. requires support for East Asian languages to be installed. This installation is available from the Control Panel Regional and Language Options applet.

  2. requires installation of either the SinhalaTamil Kit (Windows XP) or possibly a Sinhala LIP (Language Interface Pack - Windows Vista/7, untested), available from Microsoft Sri Lanka.

For anyone wishing to aid in the effort, the source files (CSV - comma separated values, XLS - Excel spreadsheet) are available for download on the translation page; completing the missing portions and re-submitting would be welcome.


Options/On Startup

Tools/Options.../On Startup

System Default: Load previous tabs

This option specifies the action Explorer++ should take on startup. Two choices are available:

  • Load previous tabs - This option forces Explorer++ to save the current tabs and settings - either in the Windows registry, or in the portable XML file - and restore them on startup. This ensures that your Tab bar (and the settings for each tab) are "just the way you left them".
  • Load default folder - This option tells Explorer++ to just open the default (new) tab at startup - no previous tabs will be loaded (but see Info and Tip below!).

The Info and Tip following are applicable to the current version (v1.2) - future versions may vary from this behavior.

Info: Explorer++ saves any tabs and settings from memory variables when the application is closed; changing from the previous tabs setting to default folder in the Options dialog only changes the setting. At the next startup, however, the memory variables will contain only the tab information specified by the setting - the previous tab settings are still in the registry or XML file, at least until Explorer++ is closed.
Tip: If you have closed Explorer++ and changed the setting to Load default folder (by accident?), you may still be able to restore your tabs for the next startup! One of the following changes (depending on whether you are using Explorer++ in portable mode or not) must be made before the next session:

Registry: The key

    HKEY_CURRENT_USER\Software\Explorer++\Settings\StartupMode

must be set to 1 (restore tabs).

XML file: The setting

    <Setting name="StartupMode">2</Setting>

must be set to 1 (2=Load default folder). Settings in the XML file should be in alphabetical order; the StartupMode setting occurs around line 59. You can edit the file with a text editor like NotePad (not a word processor!).

The usual caveats apply for Windows registry editing - don't attempt this if you are unsure.


Options/Run in portable mode

Tools/Options.../Run in portable mode

System Default: No (if no config.xml file present)

Enabling this option (ie. checking the box) tells Explorer++ to save and fetch all its settings in an XML (config.xml) file, located in the installation folder, usually ...\Program Files\Explorer++ v1.2 (your version might be different). An XML file is a text file, structured hierarchically to enable Explorer++ to re-construct its settings, etc. at program startup.

Info: At startup, Explorer++ (v1.2) always looks for a valid XML file in the correct location, and if it is found loads it and uses those settings. The actual setting value for portable mode is not saved, either in the Windows registry, or in the XML.

If Explorer++ is currently using portable mode (ie. XML file), and it is desired to switch back to using the Windows registry, the XML file must be either

  • deleted, or
  • renamed (eg. config.xml.bak)

and the portable mode option must be disabled (ie. clear the checkbox) prior to closing Explorer++, to avoid re-writing the XML file. Note that Explorer++ creates the XML file (if this setting is enabled) immediately upon closing the options dialog.


Options/Double-click to close a tab

Tools/Options.../Double-click to close a tab

System Default: Yes

When this option is enabled (ie. checked), tabs may be closed by double-clicking on the tab in the Tab bar. If disabled, the tab must be closed by an alternate method, such as the Tab bar's close button.


Options/Close the main window when closing the last tab

Tools/Options.../Close the main window when closing the last tab

System Default: Yes

Explorer++ usually disallows closure of the last open tab, but with this option enabled, this can be done, and results in Explorer++ closing completely.

With this setting active, you cannot use the close button on the Tab bar; you must use double-click (subject to option), a key combination (Ctrl+W, Ctrl+F4), or a menu item.


Options/Open new tabs next to the current one

Tools/Options.../Open new tabs next to the current one

System Default: No

New tabs on the Tab bar are normally created/opened at the extreme right position. This option, when checked, forces new tabs to be created to the immediate right of the active tab. This position for the tab is used even if the tab is created by a non-active tab elsewhere on the Tab bar using the Context menu, for example.


Options/Allow multiple instances

Tools/Options.../Allow multiple instances

System Default: Yes

By default, Explorer++ allows multiple instances of itself, that is, you may open more a one copy of Explorer++. Each new copy can have its own set of tabs and settings, etc., subject to information below. If this option is disabled (box unchecked), ie. do not allow multiple instances, then attempting to open a second copy of Explorer++ (eg. by double-clicking on a shortcut) will open a new tab instead.

Info: While multiple instances of Explorer++ are open, each copy maintains tab and settings information in its own memory space. However, on closing, each copy will write complete settings information to the Windows registry (or config.xml file). Closing the next copy will also do this, overwriting the settings from the first. This means that the last closed instance of Explorer++ ultimately determines the settings (and tab information) saved for the next session. This behavior is by design.
Tip: If you have multiple copies of Explorer++ open, the one with your preferred tabs (and settings) should be closed last. If multiple instances are being used along with portable mode, you can make a backup copy of your config.xml file.


Options/Disable treeview delay

Tools/Options.../Disable treeview delay

System Default: Yes

Explorer++ can, if desired, introduce a 500 millisecond delay between selecting a folder in the Folders pane (ie. treeview control) and opening its contents in the Files pane. This delay is entirely cosmetic; it may prove useful for users who navigate the folder tree using the keyboard. With the delay, using the up/down arrow keys would not open the folders contents for each folder as the selection was moved up or down.

By default, this option is enabled, disabling the treeview delay; clearing the checkbox enables the delay.


Options/Full row selection in details view

Tools/Options.../Full row selection in details view

System Default: No

Normal selection of an item in details view just highlights the left-most column (usually Name). In order to select that item, the left-most column must be clicked; clicking on another column has no effect.

However, when this option is enabled, the full row is highlighted; selection may be done on any column.


Options/Tab bar settings

Tools/Options.../Tab bar settings

Always show the tab bar

System Default: Yes

Disabling this option causes the Tab bar to disappear (ie. not displayed) when only 1 tab is open. If 2 or more tabs are open, this setting has no effect.

Show the tab bar at the bottom

System Default: No

The Tab bar is normally displayed at the top of the Files pane; enabling this option (ie. checking the box) displays tabs at the bottom, just above the Status Bar (if enabled).

Extend tab bar across entire window

System Default: No

With this option disabled, the Tab bar extends only the width of the Files pane. Enabling this option displays the Tab bar the full width of the window; more tabs can be displayed in this mode.


Options/Title bar settings

Tools/Options.../Title bar settings

These settings modify Explorer++'s title bar, which normally only displays the current folder, followed by "Explorer++". A sample title bar follows, showing only the current folder ("AtomExplorer").

Note that these options may be enabled in any combination. The more options enabled, the longer the window title.

Show full path in title bar

System Default: No

Enabling this setting displays the full path to the current folder. The following image demonstrates this.

Show username in title bar

System Default: No

Enabling this setting displays the current user's name (actually the owner of the Explorer++ process), preceded by the domain name. The domain name refers to the location of the user's account, which could be another computer on a network. In most cases, individual computers will just show "DESKTOP" signifying this is a local account/user.

Show privilege level in title bar

System Default: No

Enabling this setting displays the user's privilege level, as determined by the type of his account. This is usually one of

  • Administrators - high privilege, unrestricted access to all computer functions
  • Power Users - extensive rights, but may not be allowed certain administrative tasks (eg. take ownership of files)
  • Users - fewer rights. This prevents accidental changes to the system.
  • Guests - fewer rights than Users


View/Sort By/Sort order

View/Sort By ► /Sort order

Current sorting target

The current sorting target must be an enabled column, which would be shown in Details view. This may be any column, but some are more useful that others. Sorting by Name, for example, places items in alphabetical order, while sorting using the Owner (as per Windows security and permissions settings) column may yield results which are essentially unusable, since likely all files have the same owner.

Following is a list of just a few common sorting targets available in the current version of Explorer++. See Select Columns... for a more complete list.

Name | - this is the file name, including extension
Type | - Windows registered file type (eg. JPEG image)
Size | - file size (actual, in bytes)
Date Modified | - last date file was modified/changed
Attributes | - eg. read-only, hidden, system
Extension | - just the file extension (eg. txt)

Note that the list of available sorting targets (ie. Sort By menu) may change depending the active folder. Some special folders, such as My Computer, for example, have a different list of sorting targets (or display columns) than others.

Sort direction

Items for display may be sorted in

  • ascending order, that is, alphabetically - a before b, smaller before larger, etc., or
  • descending order, that is, alphabetically - b before a, larger before smaller, etc.,

depending on your preference. For example, with Date Modified as the target, it may be more desirable to use descending order, thereby placing the most recent items at the top of the list. If you are trying to locate files with zero length, then using an ascending sort with Size as the target places zero length files at the top of the list.

Since the sorting target is always an enabled column (as would be shown in Details view), the column heading reflects both the target and direction, as shown in the vertical arrow.

Name/Ascending | Name/Descending

More...

This menu item opens the Select Columns... dialog allowing you to enable additional columns, or disable existing ones. Once the columns are managed, the Sort By ► menu must be re-opened to set a different sorting target.